# common.s - common routines for lx/tx/zx
# Copyright (C) 2000-2005 Tachibana Eriko


* Include File -------------------------------- *

		.include	common.mac

		.include	doscall.mac
		.include	iocscall.mac


* Text Section -------------------------------- *

		.cpu	MPU

		.text
		.even


* MPU `FbN -------------------------------- *

.if MPU>=68020
mpu_check::
		PUSH	d0/a1
		lea	($cbc),a1
		IOCS	_B_BPEEK
		subq.b	#(MPU-68000)/10,d0
		bcc	@f
		pea	(mpu_error_mes,pc)
		DOS	_PRINT
		DOS	_EXIT
@@:
		POP	d0/a1
		rts

mpu_error_mes:	.dc.b	'680','0'+(MPU-68000)/10,'0ȍ~pł',CRLF,0
		.even

.endif


* R\[o ------------------------------ *

init_atty_flag::
.ifdef NEWLINE_AUTO
		pea	(0<<16+1)		;Wo
		DOS	_IOCTRL
		ori	#$7ffd,d0		;LN^foCX && Wo̓foCX
		not	d0
		tst.l	d0
		seq	(atty_flags+0-work,a6)

		addq.l	#1,(sp)			;WG[o
		DOS	_IOCTRL
		ori	#$7ffd,d0		;LN^foCX && Wo̓foCX
		not	d0
		move.l	d0,(sp)+
		seq	(atty_flags+1-work,a6)
.endif
		rts

.ifdef NEWLINE_AUTO
atty_flags:
		.dc.b	-1,-1
		.even
.endif

_eprint2::
		pea	(esc_0_mes,pc)
		bsr	_eprint
		move.l	(4+4,sp),(sp)
		bsr	_eprint
		pea	(esc_1_mes,pc)
		bsr	_eprint
		addq.l	#8,sp
		rts

_eprint::
		move	(message_level-work,a6),d0
		bne	_print2
print_end:	rts

_print::
		tst	(message_level-work,a6)
		beq	print_end
		moveq	#1,d0			;Wo
_print2:
		move	d0,-(sp)
.ifdef NEWLINE_AUTO
		move.b	(atty_flags-1,pc,d0.w),d0
		beq	print_lf
.endif

;[ւ̕\Ȃ CR,LF ̂܂܏o͂
		move.l	(4+2,sp),-(sp)
		DOS	_FPUTS
		addq.l	#6,sp
		rts

.ifdef NEWLINE_AUTO
;t@Cւ̏o͂Ȃ LF ɒu
print_lf:
		move	(sp)+,d0
		move.l	a0,-(sp)
		movea.l	(4+4,sp),a0		;

		move	d0,-(sp)		;WoorWG[o
		subq.l	#4,sp
		bra	print_lf_loop
print_lf_cr:
		clr.b	-(a0)			;CR ̒O܂ł\
		DOS	_FPUTS
		move.b	#CR,(a0)+
print_lf_loop:
@@:		cmpeq	#CR,(a0)+,@b		;擪 CR ΂
		subq.l	#1,a0
		move.l	a0,(sp)

		move.b	(a0)+,d0
		beq	print_lf_end
@@:
		cmpeq	#CR,d0,print_lf_cr
		move.b	(a0)+,d0
		bne	@b

		DOS	_FPUTS			;Ō܂ CR ͂Ȃ
print_lf_end:
		addq.l	#6,sp
		movea.l	(sp)+,a0
		rts
.endif


* lϊ ------------------------------ *
* in	d0-d1/a1
* out	
* break	d0-d2

cnv_num::
		adda	d1,a1
		move.l	a1,-(sp)
		clr.b	(a1)
		subq	#1,d1
cnv_num1:
		cmpi.l	#$ffff*10,d0
		bcc	cnv_num2

		divu	#10,d0
		swap	d0
		addi.b	#'0',d0
		move.b	d0,-(a1)
		clr	d0
		swap	d0
		dbeq	d1,cnv_num1
		bne	cnv_num9
		bra	cnv_num4
cnv_num2:
		moveq	#0,d2
		swap	d0
		move	d0,d2
		divu	#10,d2
		move	d2,d0
		swap	d0
		move	d0,d2
		divu	#10,d2
		move	d2,d0
		swap	d2
		addi.b	#'0',d2
		move.b	d2,-(a1)
		dbeq	d1,cnv_num1
		bra	cnv_num4
cnv_num3:
		move.b	#SPC,-(a1)
cnv_num4:
		dbra	d1,cnv_num3
cnv_num9:
		movea.l	(sp)+,a1
		rts


* 񐔒lϊ ------------------------------ *
* in	a2
* out	d0
* break	d1

get_num::
		moveq	#0,d0
get_num1:
		moveq	#0,d1
		move.b	(a2)+,d1
		subi.b	#'0',d1
		cmpi.b	#10,d1
		bcc	get_num2

		add.l	d0,d0
		add.l	d0,d1
		add.l	d0,d0
		add.l	d0,d0
		add.l	d1,d0
		bra	get_num1
get_num2:
		subq.l	#1,a2
		rts


* WJt@C쐬 -------------------------- *
* in	a1
* out	a1
* break	d0

base::
		move.l	a2,-(sp)
		cmpne	#'/',(a1),@f
		addq.l	#1,a1
@@:
		move.l	a1,-(sp)
		lea	(branch_table+512,a6),a2
		btst	#F_BASE,D7
		beq	base1
		movea.l	(base_directory,a6),a1
@@:
		move.b	(a1)+,(a2)+
		bne	@b
		subq.l	#1,a2
base1:
		btst	#F_NO_DIR,d7
		beq	base4
		movea.l	(sp),a1
base2:
		move.l	a1,(sp)
@@:
		move.b	(a1)+,d0
		beq	base4
		cmpeq	#'/',d0,base2
		bra	@b
base4:
		movea.l	(sp)+,a1
@@:
		move.b	(a1)+,(a2)+
		bne	@b
		movea.l	(sp)+,a2
		lea	(branch_table+512,a6),a1
		rts


* t@C폜 -------------------------------- *
* in	d1

file_delete::
		move	d1,-(sp)
		DOS	_CLOSE
		move	#1<<ATR_ARC,(sp)
		pea	(filename_work,a6)
		DOS	_DELETE
		tst.l	d0
		bpl	@f
		DOS	_CHMOD
		DOS	_DELETE
@@:
		addq.l	#6,sp
		rts


* t@C쐬 -------------------------------- *
* in	d2-d3/a1
* out	d0
* break	d1

file_create_sub::
		bsr	base
		move	d2,-(sp)
		move.l	a1,-(sp)
		moveq	#'/',d1
@@:
		move.b	(a1)+,d0
		beq	@f
		cmpne	d1,d0,@b
		clr.b	-(a1)
		DOS	_MKDIR
		move.b	d1,(a1)+
		bra	@b
@@:
		DOS	_NEWFILE
		tst.l	d0
		bpl	file_write6
		moveq	#-13,d1
		cmp.l	d1,d0
		beq	file_name_error

		movea.l	(sp),a1
		lea	(-54,sp),sp
		move	#$00ff,-(sp)
		pea	(a1)
		pea	(6,sp)
		DOS	_FILES
		move.l	(10+22,sp),d1
		swap	d1
		lea	(10+53+1,sp),sp
		tst.l	d0
		bmi	file_create_error

		btst	#F_OVER_W,d7
		bne	file_write5
		cmpi.b	#1,(compare_level-work,a6)
		bcs	file_write5
		bhi	@f
		cmp.l	d3,d1
		bcs	file_write5
@@:
		btst	#F_NO_INQ,D7
		bne	not_copy
file_write4:
		bsr	_eprint2
		EPRINT2	(inquire_message-work,a6)
		lea	(inquire_table1-work,a6),a1
		bsr	option
		beq	not_copy
		subq	#2,d0
		bcs	rename_copy
		beq	over_write
		bra	over_write_all

file_name_error:
		btst	#F_NO_INQ,D7
		bne	file_create_error

		bsr	_eprint2
		EPRINT2	(file_name_error_message-work,a6)
		lea	(inquire_table2-work,a6),a1
		bsr	option
		subq	#1,d0
		bcs	not_copy
		beq	file_name_error1
substitution:
		lea	(branch_table+256,a6),a1
		PUSH	a0-a1
		move.l	(8,sp),a0
substitution1:
		move.l	a1,d1
substitution2:
		move.b	(a0)+,d0
		move.b	d0,(a1)+
		beq	substitution3
		cmpeq	#'/',d0,substitution1
		cmpne	#':',d0,substitution2
		move.l	a1,d0			;擪 d: ȊO
		sub.l	d1,d0			;pXf~^ƂĈȂ
		subq.l	#2,d0
		beq	substitution1
		bra	substitution2
substitution3:
		move.l	d1,a0
		move.l	d1,a1
		addq.l	#1,a0
		moveq	#0,d1
@@:
		move.b	(a0)+,d0
		beq	substitution4
		cmpi.b	#'.',d0
		bne	@b
		move.l	a0,d1
		bra	@b
substitution4:
		move.b	(a1)+,d0
		beq	substitution5
		lea	(subst_table-work,a6),a0
@@:
		tst.b	(a0)
		beq	substitution4
		cmp.b	(a0)+,d0
		addq.l	#1,a0
		bne	@b
		move.b	-(a0),(-1,a1)
		bra	substitution4
substitution5:
		tst.l	d1
		beq	@f
		move.l	a1,d0
		sub.l	d1,d0
		subq	#1+3,d0
		bhi	@f
		movea.l	d1,a1
		move.b	#'.',-(a1)
@@:
		POP	a0-a1
		pea	(substitution6-work,a6)
		bra	rename_copy2
substitution6:
		pea	(file_name_error-work,a6)
		bra	rename

file_name_error1:
		pea	(file_name_error-work,a6)
		bra	rename_copy1

not_copy:
		bsr	_eprint
		EPRINT	(not_copy_message-work,a6)
		addq.l	#6,sp
		moveq	#-1,d0
		rts

rename_copy:
		pea	(file_write4-work,a6)
rename_copy1:
		movea.l	(4,sp),a1
rename:
		EPRINT	(rename_copy_message-work,a6)
		move.l	a0,-(sp)
		lea	(branch_table,a6),a0
		clr	(a0)+
		move.l	a0,d1
rename0:
		moveq	#0,d0
		move.b	(a1),d0
		lsr.b	#5,d0
		btst	d0,#%10010000
		beq	@f
		move.b	(a1)+,-(sp)
		move	(sp)+,d0
@@:
		move.b	(a1)+,d0
		move	d0,(a0)+
		bne	rename0

		subq.l	#2,a0
		movea.l	a0,a1
		move.l	d1,a0
rename1:
		PUSH	a0-a2
		movea.l	a1,a2
@@:
		tst	(a1)+
		bne	@b
		move.l	a1,-(sp)
		moveq	#0,d1
rename1a:
		cmpa.l	a2,a0
		bne	@f
		move.l	a1,d1
@@:
		move.b	(a0)+,(a1)+
		bne	@f
		subq.l	#1,a1
@@:
		move.b	(a0)+,(a1)+
		bne	rename1a
		subq.l	#1,a1

		move.l	#$000900ff,-(sp)
		DOS	_CONCTRL
		move.l	#$0008000e,-(sp)
		DOS	_CONCTRL
		addq.l	#8,sp
		bsr	_eprint
		move.l	#$000b0000,-(sp)
		DOS	_CONCTRL
		addq.l	#8,sp
		move	a1,d0
		sub	d1,d0
		beq	@f

		move	d0,-(sp)
		move	#9,-(sp)
		DOS	_CONCTRL
		addq.l	#4,sp
@@:
		POP	a0-a2
rename2:
		DOS	_GETC
		cmpi	#$20,d0
		bcs	rename4

		move	d0,d1
		lsr.b	#5,d0
		btst	d0,#%10010000
		beq	@f
		DOS	_GETC
		lsl	#8,d1
		move.b	d0,d1
@@:
		move.l	a1,d0
		sub.l	a0,d0
		cmpi	#80*2,d0
		bcc	rename1

		move.l	a1,-(sp)
@@:
		move	d1,d0
		move	(a1),d1
		move	d0,(a1)+
		bne	@b

		movea.l	(sp)+,a1
		addq.l	#2,a1
		bra	rename1
rename4:
		cmpeq	#CR,d0,rename_cr
		cmpeq	#DEL,d0,rename_delete
		cmpeq	#BS,d0,rename_backspace
		cmpeq	#LEFT,d0,rename_left
		cmpeq	#RIGHT,d0,rename_right
		cmpeq	#ESC,d0,rename_escape
		bra	rename2
rename_backspace:
		cmpa.l	a0,a1
		beq	rename2
		subq.l	#2,a1
rename_delete:
		tst	(a1)
		beq	rename2
rename_delete1:
		move.l	a1,-(sp)
@@:
		move	(2,a1),(a1)+
		bne	@b
		movea.l	(sp)+,a1
		bra	rename1
rename_left:
		cmpa.l	a0,a1
		beq	rename2
		subq.l	#2,a1
		bra	rename1
rename_right:
		tst	(a1)
		beq	rename2
		addq.l	#2,a1
		bra	rename1
rename_escape:
		movea.l	(sp)+,a0
rename_clear:
		EPRINT2	(inquire_clear_message-work,a6)
		EPRINT	(crlf_mes-work,a6)
		rts
rename_cr:
		tst	(a0)+
		bne	rename_cr
		movea.l	a0,a1
		movea.l	(sp)+,a0
		bsr	rename_clear
rename_copy2:
		move	d2,-(sp)
		move.l	a1,-(sp)
		DOS	_NEWFILE
		addq.l	#6,SP
		tst.l	D0
		bpl	rename_copy3

		clr	-(sp)
		move.l	a1,-(sp)
		bsr	_eprint2
		DOS	_OPEN
		addq.l	#6,sp
		tst.l	d0
		bmi	@f

		move	d0,-(sp)
		DOS	_CLOSE
		addq.l	#2,sp
		EPRINT2	(rename_error_message-work,a6)
		rts
@@:
		EPRINT2	(rename_error_message2-work,a6)
		rts

rename_copy3:
		addq.l	#4,sp
		move.l	a1,(sp)
		bra	file_write6

over_write_all:
		bset	#F_OVER_W,d7
over_write:
file_write5:
		DOS	_CREATE
file_write6:
		move.l	a0,d1
		movea.l	(sp),a0
		lea	(filename_work,a6),a1
@@:
		move.b	(A0)+,(A1)+
		bne	@b
		addq.l	#6,sp
		movea.l	d1,a0

		tst.b	(disk_free_check_flag-work,a6)
		bne	file_create9

		move.l	d0,-(sp)
		lea	(filename_work,a6),a1
		moveq	#0,d0
		cmpne	#':',(1,a1),@f
		moveq	#$1f,d0
		and.b	(a1),d0
@@:
		subq.l	#8,sp
		move.l	sp,-(sp)
		move	d0,-(sp)
		DOS	_DSKFRE
		move.l	d0,d1
		lea	(6+8,sp),sp
		move.l	(sp)+,d0
		cmp.l	(percentage_work1,a6),d1
		bcc	file_create9
disk_free_check_error:
		move	d0,d1
		bsr	file_delete
		EPRINT	(disk_free_check_error_message-work,a6)
		moveq	#-1,d0
file_create9:
		rts

file_create_error:
		bsr	_eprint
		EPRINT	(file_create_error_message-work,a6)
		addq.l	#6,sp
		moveq	#-1,d0
		rts


* I ---------------------------------------- *
* in	a1
* out	d0
* break	d1

option:
		EPRINT2	(10,a1)
		moveq	#0,d1
		move.b	(a1),d1
		clr	-(sp)
option1:
		moveq	#0,d0
		move.b	(6,a1,d1.w),d0
		sub	(sp),d0
		add	d0,(sp)
		beq	option4
		bcs	option2

		move	d0,-(sp)
		move	#8,-(sp)
		bra	option3
option2:
		neg	d0
		move	d0,-(sp)
		move	#9,-(sp)
option3:
		DOS	_CONCTRL
		addq.l	#4,sp
option4:
		move	#8,-(sp)
		DOS	_KFLUSH
		move	d0,(sp)
		move.l	#$0003_0007,-(sp)
		DOS	_KEYCTRL
		addq.l	#4,sp

		btst	#3,d0
		beq	@f

		addq.l	#2,sp
		subq.b	#1,d1
		bcc	option1
		add.b	(1,a1),d1
		bra	option1
@@:
		btst	#5,d0
		beq	@f

		addq.l	#2,sp
		addq.b	#1,d1
		cmp.b	(1,a1),d1
		bcs	option1
		moveq	#0,d1
		bra	option1
@@:
		move	(sp)+,d0
		CMPEQ	#CR,D0,option8
		CMPEQ	#ESC,D0,option5
		ori.b	#$20,d0
		CMPNE	(2,a1),d0,@f
option5:
		moveq	#0,d0
		bra	option9
@@:
		CMPNE	(3,a1),d0,@f
		moveq	#1,d0
		bra	option9
@@:
		CMPNE	(4,a1),d0,@f
		moveq	#2,d0
		bra	option9
@@:
		CMPNE	(5,a1),d0,option4
		moveq	#3,d0
		bra	option9
option8:
		move	d1,d0
option9:
		move.b	d1,(a1)
		move	d0,(sp)
		EPRINT2	(inquire_clear_message-work,a6)
		move	(sp)+,d0
		rts


* t@Cr ------------------------------ *
* in	a1
* out	ccrZ
* break	d0-d2/a0-a1

filename_compare::
		btst	#F_EXT,d7
		beq	1f			;ext-file wȂSēWJ

		movea.l	(ext_file,a6),a0
		move.l	a1,-(sp)
filename_compare1:
		moveq	#$20,d2
		tst.b	(a0)
		bne	@f
		tst.l	(sp)+			;sv (a1 != null)
1:		rts
@@:
		movea.l	(sp),a1
filename_compare4:
		move.b	(a1)+,d1
		move.b	(a0)+,d0
		bne	@f
		tst.b	d1
		bne	filename_compare1
		addq.l	#4,sp			;v
		rts
@@:
		tst	d2
		bmi	@f
		CMPEQ	#'?',d0,wildcard1
		CMPEQ	#'*',d0,wildcard2
		tst.b	d0
		bpl	filename_compare5
		cmpi.b	#$a0,d0
		bcs	@f
		cmpi.b	#$e0,d0
		bcs	filename_compare5
@@:
		bchg	#15,d2
		bra	filename_compare6
filename_compare5:
		btst	#F_CASE,d7
		bne	filename_compare6
		cmpi.b	#'A',d0
		bcs	@f
		cmpi.b	#'Z',d0
		bhi	@f
		or.b	d2,d0
@@:
		cmpi.b	#'A',d1
		bcs	@f
		cmpi.b	#'Z',d1
		bhi	@f
		or.b	d2,d1
@@:
filename_compare6:
		CMPEQ	d1,d0,filename_compare4
@@:
		tst.b	(A0)+
		bne	@b
		bra	filename_compare1
wildcard1:
		moveq	#1-1,d1
		bra	wildcard3
wildcard2:
		moveq	#0-1,d1
wildcard3:
		subq.l	#1,a1
@@:
		move.b	(a1)+,d0
		beq	@f
		CMPEQ	(a0),d0,@f
		subq	#1,d1
		bcs	filename_compare4
		add.b	d0,d0
		bcc	@b
		rol.b	#2,d0
		andi.b	#3,d0
		subq.b	#1,d0
		subq.b	#2,d0
		bcs	@b
		addq.l	#1,a1
		bra	@b
@@:
		subq.l	#1,a1
		bra	filename_compare4


* Data Section -------------------------------- *

		.data
		.even

exit_code::	.dc	0
status::	.ds	1

link::
		.dc.l	0
src_total_size::
		.dc.l	0
ext_total_size::
		.dc.l	0
file_total::
		.dc	0
request_total::
		.dc	-1

message_level::
		.dc	2

crc_check_level::
		.dc.b	0
compare_level::
		.dc.b	2
disk_free_check_flag::
		.dc.b	-1

month_table::	.dc.b	31,28,31,30,31,30,31,31,30,31,30,31
month_table2::	.dc.b	31,29,31,30,31,30,31,31,30,31,30,31

inquire_table1:
		.dc.b	0,4,'i','r','o','a',2,10,18,28
		.dc.b	' [I] [R] [O]㏑ [A]S㏑',ESC,'[38D',0

inquire_table2:
		.dc.b	0,3,'i','r','s',$ff,2,10,18,$ff
		.dc.b	' [I] [R] [S]',ESC,'[24D',0

subst_table:
		.dc.b	SPC,'_'
		.dc.b	'"','`'
		.dc.b	"'",'`'
		.dc.b	'+','_'
		.dc.b	',','_'
		.dc.b	'-','_'
		.dc.b	'.','_'
		.dc.b	';','_'
		.dc.b	'<','_'
		.dc.b	'>','_'
		.dc.b	'[','_'
		.dc.b	']','_'
		.dc.b	'|','_'
		.dc.b	':','_'
		.dc.b	0

esc_0_mes:	.dc.b	ESC,'0',0
esc_1_mes:	.dc.b	ESC,'1',0


memory_alloc_error_message::
* bZ[Wǉꍇ tx.s  memory_alloc_error
*  gzip_memory_error C邱.
memory_error_message::
		.dc.b	'sĂ܂',CRLF,0

file_read_error_message::
		.dc.b	't@C\ُł',CRLF,0

format_error_message::
		.dc.b	'f[^\ُł',CRLF,0

system_error_message::
		.dc.b	'VXeG[',CRLF,0

branch_error_message::
		.dc.b	'u`G[',CRLF,0

crc_error_message::
		.dc.b	'CRCG[',CRLF,0

file_create_error_message:
		.dc.b	' 쐬ł܂',CRLF,0

disk_free_check_error_message:
		.dc.b	'󂫗eʂsĂ܂',CRLF,0

file_write_error_message::
		.dc.b	' ߂܂',CRLF,0

inquire_message:
		.dc.b	' ɑ݂܂',0
inquire_clear_message:
		.dc.b	ESC,'[96D',ESC,'[K',0
not_copy_message:
		.dc.b	' ݂܂',CRLF,0
rename_copy_message:
		.dc.b	'Vt@CF',0
file_name_error_message:
		.dc.b	' t@Csł',0
rename_error_message:
		.dc.b	' ͊ɑ݂܂',CRLF,0
rename_error_message2:
		.dc.b	' ͎gpł܂'	;,CRLF,0

crlf_mes:	.dc.b	CRLF,0

archive_message::
		.dc.b	'Archive: ',0

stdout_message::
		.dc.b	'<Wo>',0

switch_error_message::
		.dc.b	'ȃXCb`w肵܂',CRLF,0

command_error_message::
		.dc.b	'R}hCُł',CRLF,0

file_open_error_message::
		.dc.b	' I[vł܂',CRLF,0

*change_directory_error_message:
*		.dc.b	' ݂܂',CRLF,0


* Stack Section ------------------------------- *

		.stack
		.even
work::


		.end

* End of File --------------------------------- *
