*
* X68k LX.R version 1.20 Copyright 1994,95 M.Harashino
*


* Patchlevel ---------------------------------- *

LX_PATCHLEVEL:	.reg	'2'
LX_PATCHDATE:	.reg	'2005-12-27'
LX_PATCHAUTHOR:	.reg	''


* Include File -------------------------------- *

		.include	common.mac
		.include	archive.mac

		.include	doscall.mac


* Fixed Number -------------------------------- *

el1:		.equ	10
el2:		.equ	4

margin:		.equ	1024
work_size:	.equ	1024
branch_max:	.equ	1024
lh1_dic_size:	.equ	$1000
search_length:	.equ	$1000


* Macro --------------------------------------- *

BIT:		.macro	num,reg
.if num.eq.1
		moveq	#0,reg
		add.l	d5,d5
		addx	reg,reg
		dbra	d6,@skip

		move	(a4)+,d5
		moveq	#16-1,d6
@skip:
.elseif (2<=num).and.(num<=4)
		rol.l	#num,d5
		moveq	#(1<<num)-1,reg
		and	d5,reg
		subq	#num,d6
		bcc	@skip

		not	d6
		ror.l	d6,d5
		move	(a4)+,d5
		rol.l	d6,d5
		not	d6
		addi	#16,d6
@skip:
.elseif num.eq.8
		swap	d5
		move.l	d5,reg
		lsr	#16-8,reg
		ror.l	#16-8,d5
		subq	#8,d6
		bcc	@skip

		not	d6
		ror.l	d6,d5
		move	(a4)+,d5
		rol.l	d6,d5
		not	d6
		addi	#16,d6
@skip:
.elseif num.eq.9
		swap	d5
		move.l	d5,reg
		lsr	#16-9,reg
		ror.l	#16-9,d5
		subi	#9,d6
		bcc	@skip

		not	d6
		ror.l	d6,d5
		move	(a4)+,d5
		rol.l	d6,d5
		not	d6
		addi	#16,d6
@skip:
.elseif	num.eq.16
		move.l	d5,reg
		swap	reg
		addq	#1,d6
		rol	d6,d5
		swap	d5
		move	(a4)+,d5
		ror.l	d6,d5
		swap	d5
		subq	#1,d6
.else
		.dc	0/0
.endif
		.endm

BITREG:		.macro	num,reg
		move.l	d5,reg
		clr	reg
		rol.l	num,reg
		rol.l	num,d5
		sub.b	num,d6
		bcc	@skip

		not.b	d6
		ror.l	d6,d5
		move	(a4)+,d5
		rol.l	d6,d5
		not.b	d6
		addi.b	#16,d6
@skip:
		.endm

BITPASS:	.macro	num
		rol.l	num,d5
		sub.b	num,d6
		bcc	@skip

		not.b	d6
		ror.l	d6,d5
		move	(a4)+,d5
		rol.l	d6,d5
		not.b	d6
		addi.b	#16,d6
@skip:
		.endm


* Text Section -------------------------------- *

		.cpu	68000

		.text
		.even

start:
		bra.s	@f
		.dc.b	'#HUPAIR',0
@@:
		lea	(work,pc),a6
.if MPU>=68020
		bsr	mpu_check
		.cpu	MPU
.endif
		bsr	init_atty_flag

	pea	(work+bss_bottom-start+$f0.w)
	pea	(16,a0)
	DOS	_SETBLOCK
	addq.l	#8,sp
	tst.l	d0
	bmi	memory_alloc_error

	move.l	#$ffffff,-(sp)
	DOS	_MALLOC
	and.l	D0,(sp)
	DOS	_MALLOC
	movea.l	(sp)+,A0
	tst.l	D0
	bmi	memory_alloc_error
	cmpa	#work_size,a0
	bcs	memory_alloc_error

		movea.l	d0,a5
		adda.l	d0,a0
		move.l	a0,(temp_bottom,a6)

		moveq	#0,d7			;etOAIvV

	pea	1(A2)
	movea.l	A5,A2
	move.l	A2,-(SP)
	clr.l	-(SP)
	pea	lx_opt-work(A6)
	DOS	_GETENV
	addq.l	#12-4,sp
	move.l	d0,(sp)+
	bmi	@f
	bsr	get_command
@@:
	movea.l	(SP)+,A2
	bsr	get_command
	bsr	get_command9
	setquad	A5
	bsr	make_crc_table

main:
		movea.l	(lzh_file,a6),a0
		move.l	a0,d1

wild_card_check:
	move.b	(A0)+,D0
	beq	singular_archive
	cmpeq	#'?',D0,plural_archives
	cmpne	#'*',D0,wild_card_check
wild_card_check9:

plural_archives:
	move.w	#-1,request_total-work(A6)
	move.l	D1,A0
	move.l	A5,A1
	lea	53+1(A5),A5
		move.l	a5,(temp_top,a6)

		move	#$ff,-(SP)
	move.l	A0,-(SP)
	move.l	A1,-(SP)
	DOS	_FILES
	tst.l	D0
	bpl	plural_archives1

	bsr	complete_ext
	DOS	_FILES
	tst.l	D0
	bmi	file_open_error
plural_archives1:
		movea.l	(sp),a5
		moveq	#%0001_1000,d0		;DIR/VOL
		and.b	(21,a5),d0		;t@C̑
		bne	plural_archives5
		movea.l	(4,sp),a1
	lea	53+1(A5),A0
	movea.l	A0,A2
plural_archives2:
	move.l	A2,D1
plural_archives3:
	move.b	(A1)+,D0
	move.b	D0,(A2)+
	beq	plural_archives4
	cmpeq	#'/',D0,plural_archives2
	cmpeq	#':',D0,plural_archives2
	bra	plural_archives3
plural_archives4:
	lea	30(A5),A1
	move.l	D1,A2
@@:
	move.b	(A1)+,(A2)+
	bne	@b
	clr.w	-(SP)
	move.l	A0,-(SP)
	DOS	_OPEN
	addq.w	#6,SP
	move.l	D0,D6
	bmi	file_open_error
	move.w	D6,-(SP)
	bsr	extract
	DOS	_CLOSE
	addq.w	#2,SP
plural_archives5:
	DOS	_NFILES
	tst.l	D0
	bpl	plural_archives1
	lea	10(SP),SP
	bra	done1
plural_archives9:

singular_archive:
		move.l	a5,(temp_top,a6)
		move.l	d1,a0

	clr.w	-(SP)
	move.l	A0,-(SP)
	DOS	_OPEN
	addq.w	#6,SP
	move.l	D0,D6
	bpl	singular_archive1

	bsr	complete_ext
	clr.w	-(SP)
	move.l	A0,-(SP)
	DOS	_OPEN
	addq.w	#6,SP
	move.l	D0,D6
	bmi	file_open_error
singular_archive1:
	move.w	D6,-(SP)
	bsr	extract
	DOS	_CLOSE
	addq.w	#2,SP
	bra	done1
singular_archive9:

done:
	move.w	#1,exit_code-work(A6)
done1:
	move.w	exit_code-work(A6),-(SP)
	DOS	_EXIT2

file_open_error:
	EPRINT	(a0)
	EPRINT	file_open_error_message-work(A6)
	bra	done

****************************************************************

complete_ext:
	move.l	A0,-(SP)
@@:
	tst.b	(A0)+
	bne	@b
	subq.w	#1,A0
	lea	lzh_ext-work(A6),A1
@@:
	move.b	(A1)+,(A0)+
	bne	@b
	movea.l	(SP)+,A0
	rts

****************************************************************

extract:
		move.l	sp,(stack2,a6)
	move.w	D7,status-work(A6)
	clr.l	src_total_size-work(A6)
	clr.l	ext_total_size-work(A6)
	clr.w	file_total-work(A6)

		tst	(message_level-work,a6)
		beq	@f
		tst.b	d7
		bmi	@f

		pea	(archive_message,pc)
		DOS	_PRINT
		move.l	a0,(sp)
		DOS	_PRINT
		addq.l	#4,sp
		PRINT	(item_list-work,a6)
@@:

		movea.l	(temp_top,a6),a5
extract1:
		setquad	a5

		move	(file_handle-work,a6),d1
		beq	@f
		bsr	file_delete
@@:

		move.l	#work_size+$10000,D0
		add.l	a5,d0
		cmp.l	(temp_bottom,a6),d0
		bcs	@f

		bsr	file_write
		movea.l	(temp_top,a6),a5
@@:

;WX^蓖
;	d3.l	wb_ɋLqꂽTCY(header_sizeheader_sum܂)
;	d4.l	܂łɓǂ񂾃oCg(ŏIId4=d3ƂȂAȌd4̂ݎgp)
;	d5.b	wb_x($ff=lv0 $00=lv1 $01=lv2)
;	d6.w	t@Cnh
;	d7.b	tO(F_DONE)
;	a5.l	ǂݍ݃obt@(擪1oCg͋=$00)

;wb_\ꕔp
;+21	1.l	WJf[^̃AhX
;+25	?.b	t@C(fBNg܂)
extdata_adr:=21
pathname:=25

;word/long wordf[^ǂ݈Ղ邽߁A
;obt@擪1oCg󂯂ĊAhXǂݍ
pad:=1
		clr.b	(a5)			;header_sizeǂ݈Ղ悤ɃNA

;܂Awb_ƂčŒKvȃTCY(=22oCg)ǂݍ
;(LH0_name_lengthALH1_name_length ܂)
		moveq	#LH_HEADER_MIN_SIZE,d4

		move.l	d4,-(sp)
		pea	(pad,a5)
		move	d6,-(sp)
		DOS	_READ
		addq.l	#10-4,sp
		cmp.l	(sp)+,d0
		beq	ext_header_read_ok	;22oCgǂݍ߂

;22oCg=wb_݂͑Ȃ
		tst.l	d0
		beq	file_read_error		;wb_ɏI}[NȂ
		tst.b	(pad+LH0_header_size,a5)
		bne	@f

		btst	#F_DONE,d7
		bne	extract9		;t@C $00 = ɏI}[N
@@:		bra	file_header_error	;t@C擪̃S~f[^(SFX Ȃ)

ext_header_read_ok:
		move.l	(pad+LH2_method_id-1,a5),d0
		lsl.l	#8,d0
		move.b	(pad+LH2_method_id+4,a5),d0	;'-lh-'
		cmpi.l	#'-lh-',d0
		beq	@f
		cmpi.l	#'-lz-',d0
		bne	ext_not_header
@@:
;ȍ~Awb_\sƔf犪߂Ď̃wb_TB
;قďĂ邪AG[bZ[W\ǂmȂB
;(-lh?- ܂ōĂ̂ɍ\sAR̈vł͂Ȃ
; ɂ̔j̉\)

;fBNgAt@C
		moveq	#0,d0
		move	d0,(dir_len,a6)
		move.l	d0,(dirname,a6)
		move	d0,(file_len,a6)
		move.l	d0,(filename,a6)

		move.b	(pad+LH0_header_level,a5),d5
		subq.b	#2,d5
		bhi	ext_not_header		;Ή̃wb_x
		addq.b	#1,d5			;lv0=-1 lv1=0 lv2=1
		bgt	ext_header_lv2

;lv0/lv1 ʂ̃f[^vZ

;d0.l = Œ蕔{name_length̃oCg(header_size菬΃wb_s)
		move.b	(pad+LH0_name_length,a5),d0
		addi	#LH0_HEADER_MIN_SIZE,d0
		.fail	 LH0_HEADER_MIN_SIZE.ne.LH1_HEADER_MIN_SIZE

;d3.l = header_sizeheader_sum܂ރwb_TCY
		moveq	#0,d3
		move	(pad+LH0_header_size-1,a5),d3
		.fail	LH0_header_size.ne.LH1_header_size
		addq	#LH_HEADER_SIZE_SUM,d3

		tst.b	d5
		beq	ext_header_lv1
*ext_header_lv0:
		cmp	d3,d0
		bhi	ext_not_header		;header_size < name_length+̑

		move.l	d3,d1
		sub.l	d4,d1			;܂ǂݍłȂwb_̎c
		bcs	ext_not_header		;header_size < KvŏTCY(̃`FbN͏ȗ\Ȕ)
		beq	@f

		move.l	d1,-(sp)		;wb_̎cǂݑ
		pea	(pad,a5,d4.l)
		move	d6,-(sp)
		DOS	_READ
		addq.l	#10-4,sp
		move.l	d0,(sp)+
		bmi	file_read_error

		add.l	d0,d4			;ǂݍ߂oCg
		cmp.l	d0,d1
		bne	ext_not_header
@@:
;̎_ d3=d4 ƂȂĂ
		bsr	test_checksum
		bne	ext_not_header

		bsr	ltob_longwords		;O[hlrbOGfBAɕϊ
		bra	ext_header_lv0_lv1

ext_not_header:
		subq.l	#3,d4			;1+2oCgォwb_Jn
		neg.l	d4			;wb_Ǝvēǂ񂾃f[^߂

		move	#SEEK_CUR,-(sp)
		move.l	d4,-(sp)
		move	d6,-(sp)
		DOS	_SEEK
		addq.l	#8,sp
		bra	file_header_error

;`FbNŤ
test_checksum:
		lea	(pad+LH0_method_id,a5),a0
		move.b	(pad+LH0_header_sum,a5),d0
		move	(pad+LH0_header_size-1,a5),d1
		subq	#1,d1
@@:
		sub.b	(a0)+,d0
		dbra	d1,@b
		rts

;packed_sizeAoriginal_sizeAtime/date rbOGfBAɕϊ
ltob_longwords:
		lea	(pad+LH0_packed_size,a5),a0
		moveq	#3-1,d1
@@:
		move.l	(a0),d0
		ror	#8,d0
		swap	d0
		ror	#8,d0
		move.l	d0,(a0)+
		dbra	d1,@b
		rts

ext_header_lv1:
		cmp	d3,d0
		bhi	ext_not_header		;header_size < name_length+̑

		move.l	d3,d1
		sub.l	d4,d1			;܂ǂݍłȂwb_̎c
		bcs	ext_not_header		;header_size < KvŏTCY(̃`FbN͏ȗ\Ȕ)
		beq	@f

		move.l	d1,-(sp)		;wb_̎cǂݑ
		pea	(pad,a5,d4.l)
		move	d6,-(sp)
		DOS	_READ
		addq.l	#10-4,sp
		move.l	d0,(sp)+
		bmi	file_read_error

		add.l	d0,d4			;ǂݍ߂oCg
		cmp.l	d0,d1
		bne	ext_not_header
@@:
;̎_ d3=d4 ƂȂĂ
		bsr	test_checksum
		bne	ext_not_header

		bsr	ltob_longwords		;O[hlrbOGfBAɕϊ

;gwb_ǂݍ
		lea	(pad-LH_NEXT_HEADER_SIZE,a5,d4.l),a0
		moveq	#0,d1
		moveq	#LH_EXT_HEADER_MIN_SIZE,d2
		bra	ext_header_lv1_read_start
ext_header_lv1_read_loop:
		lea	(a0,d1.l),a1
		cmpa.l	(temp_bottom,a6),a1
		bcc	memory_error

		move.l	d1,-(sp)
		pea	(a0)
		move	d6,-(sp)
		DOS	_READ
		addq.l	#10-4,sp
		move.l	d0,(sp)+
		bmi	file_read_error

		add.l	d0,d4			;ǂݍ߂oCg
		sub.l	d0,(pad+LH1_packed_size,a5)
		cmp.l	d0,d1
		bne	ext_not_header

		cmp	d2,d1
		bcs	ext_header_lv1_read_end	;3oCgƕsIƌȂ

		lea	(-LH_NEXT_HEADER_SIZE,a0,d1.l),a0	;̊gwb_TCY
ext_header_lv1_read_start:
.if MPU>=68020
		move	(a0)+,d1
.else
		move.b	(a0)+,-(sp)
		move	(sp)+,d1
		move.b	(a0)+,d1
.endif
		ror	#8,d1
		bne	ext_header_lv1_read_loop
ext_header_lv1_read_end:

ext_header_lv0_lv1:
;t@Cꎞobt@ɓ]
		moveq	#0,d0
		move.b	(pad+LH0_name_length,a5),d0
		lea	(pad+LH0_pathname,a5),a0
		lea	(branch_table,a6),a1

		move	d0,(file_len,a6)
		move.l	a1,(filename,a6)
		bra	1f
@@:
		move.b	(a0)+,(a1)+
1:		dbra	d0,@b
		bra	ext_header_ok

ext_header_lv2:
		bsr	ltob_longwords		;O[hlrbOGfBAɕϊ

;c̃wb_ǂ(gwb_܂)
		move.l	(pad+LH2_total_header_size-1,a5),d3
		lsr.l	#8,d3
		ror	#8,d3			;wb_Ŝ̃TCY

		cmpi	#LH2_HEADER_MIN_SIZE,d3
		bcs	ext_not_header		;total_header_size < KvŏTCY

		move.l	d3,d1
		sub.l	d4,d1			;܂ǂݍłȂwb_̎c
		bcs	ext_not_header		;(̃`FbN͏ȗ\Ȕ)
		beq	@f

		lea	(a0,d1.l),a1
		cmpa.l	(temp_bottom,a6),a1
		bcc	memory_error

		move.l	d1,-(sp)
		pea	(pad,a5,d4.l)
		move	d6,-(sp)
		DOS	_READ
		addq.l	#10-4,sp
		move.l	d0,(sp)+
		bmi	file_read_error

		add.l	d0,d4			;ǂݍ߂oCg
		cmp.l	d0,d1
		bne	ext_not_header
@@:
;̎_ d3=d4 ƂȂĂ

;gwb_HAsȍ\Ȃׂ
		lea	(pad+LH2_next_header_size,a5),a0
		lea	(pad,a5,d4.l),a1	;wb_
		moveq	#0,d1
		moveq	#LH_EXT_HEADER_MIN_SIZE,d2
		bra	@f
ext_header_lv2_chk_loop:
		adda.l	d1,a0			;̊gwb_
		cmpa.l	a1,a0
		bhi	ext_not_header		;gwb_TCYs

		cmp	d2,d1
		bcs	ext_header_lv2_chk_end	;3oCgƕsIƌȂ

		subq.l	#LH_NEXT_HEADER_SIZE,a0
@@:
.if MPU>=68020
		move	(a0)+,d1
.else
		move.b	(a0)+,-(sp)
		move	(sp)+,d1
		move.b	(a0)+,d1
.endif
		ror	#8,d1
		bne	ext_header_lv2_chk_loop
ext_header_lv2_chk_end:

;wb_킪mAẻ߂s
ext_header_ok:
		bset	#F_DONE,d7
		clr.l	(crc_work1,a6)
**		clr	(crc_work2,a6)

		tst.b	d5
		bgt	ext_filecrc_lv2		;lv2

;x0/x1
ext_filecrc_lv0_lv1:
		moveq	#0,d0
		move.b	(pad+LH0_name_length,a5),d0
		move.b	(pad+LH0_pathname+0,a5,d0.w),(crc+1,a6)
		move.b	(pad+LH0_pathname+1,a5,d0.w),(crc+0,a6)

		tst.b	d5
		bmi	ext_header_end		;x0Ȃwb_ߏI

		move	(pad+LH0_header_size-1,a5),d0
		lea	(pad+LH_HEADER_SIZE_SUM-LH_NEXT_HEADER_SIZE,a5,d0.w),a2
		bra	ext_exheader

;x2
ext_filecrc_lv2:
		move	(pad+LH2_file_crc,a5),d0
		ror	#8,d0
		move	d0,(crc,a6)
*ext_timestamp_lv2:
		move.l	(pad+LH2_unix_time,a5),d0
		bsr	unix2dostime
		move.l	d0,(pad+LH2_unix_time,a5)
*ext_extheader_lv2:
		lea	(pad+LH2_next_header_size,a5),a2
		bra	ext_exheader

;x1/x2 ... gwb_߂
ext_exheader:
ext_exhead_next:
		moveq	#0,d1
.if MPU>=68020
		move	(a2)+,d1
.else
		move.b	(a2)+,-(sp)
		move	(sp)+,d1
		move.b	(a2)+,d1
.endif
		ror	#8,d1
		beq	ext_header_end		;gwb_I

		lea	(a2),a0
		lea	(-LH_NEXT_HEADER_SIZE,a2,d1.l),a2	;̊gwb_

		subq	#LH_EXT_HEADER_MIN_SIZE,d1	;gwb_oCg
		bcs	ext_header_end		;3oCgƕsIƌȂ

		move.b	(a0)+,d0		;
		cmpeq	#LHEXT_FILE,d0,ext_exhead_file
		cmpeq	#LHEXT_DIR,d0,ext_exhead_dir
		cmpeq	#LHEXT_ATR,d0,ext_exhead_atr
		bra	ext_exhead_next

;gwb_ $00: wb_ CRC
;ext_exhead_common:
;		subq	#2,d1
;		bcs	@f
;		move.b	(a0)+,(crc+1,a6)
;		move.b	(a0)+,(crc+0,a6)
;@@:		bra	ext_exhead_next

ext_exhead_file:
		tst	d1
		beq	@f
		move	d1,(file_len,a6)
		move.l	a0,(filename,a6)
@@:		bra	ext_exhead_next

ext_exhead_dir:
		tst	d1
		beq	@f
		move	d1,(dir_len,a6)
		move.l	a0,(dirname,a6)
@@:		bra	ext_exhead_next

;gwb_ $40: DOSt@C
ext_exhead_atr:
		tst	d1
		beq	@f
		move.b	(a0),(pad+LH0_attribute,a5)
@@:		bra	ext_exhead_next

ext_header_end:

;(pad+pathname,a5)` ɃpXi[
		moveq	#0,d1
		moveq	#0,d2
		move	(dir_len,a6),d1
		movea.l	(dirname,a6),a1
		move	(file_len,a6),d2
		movea.l	(filename,a6),a2

		lea	(pad+pathname,a5),a0
		move.l	a1,d0
		bne	ext_cat_fn2

;fBNg̎wȂ
		move.l	a2,d0
		beq	ext_cat_fn_end		;t@C̎wȂ(lv2 s)

		bra	1f
@@:		move.b	(a2)+,(a0)+		;t@CRs[
1:		dbra	d2,@b
		bra	ext_cat_fn_end

;fBNgƃt@Cq
ext_cat_fn2:
		lea	(branch_table,a6),a4
		cmpa.l	a4,a2
		beq	ext_cat_fn3
		cmpa.l	a1,a2
		bcc	ext_cat_fn3

;t@C < fBNg
		lea	(a1,d1.l),a3		;̃fBNǧ
		adda.l	d2,a3			;t@Cqꍇ̖AhX
		cmpa.l	(temp_bottom,a6),a3
		bcc	memory_error

		suba.l	d2,a3
		add.l	d2,d1
		bra	1f
@@:
		move.b	(a2)+,(a3)+		;fBNǧɃt@Cq
1:		dbra	d2,@b
		bra	1f
@@:
		move.b	(a1)+,(a0)+		;LH0_pathnameɓ]
1:		subq.l	#1,d1
		bcc	@b
		bra	ext_cat_fn_end

;fBNg < t@C(܂ t@C=branch_table)
@@:
		move.b	(a1)+,(a0)+		;fBNgRs[
ext_cat_fn3:	dbra	d1,@b
		bra	1f
@@:
		move.b	(a2)+,(a0)+		;̌Ƀt@CRs[
1:		dbra	d2,@b
ext_cat_fn_end:
		clr.b	(a0)+
		lea	(a0),a4			;ȍ~Ɨpobt@ƂĎgp

;pX̐K
;	pXy[X _ ɕϊ
;	\ y $ff  / ɕϊ
ext_regular_fn:
		lea	(pad+pathname,a5),a0
		moveq	#'\',d1
		moveq	#$ff,d2
		moveq	#SPC,d3
		bra	ext_regular_fn_loop
@@:
		move.b	#'/',(-1,a0)
ext_regular_fn_loop:
		move.b	(a0)+,d0
		beq	ext_regular_fn_end
		cmpeq	d0,d1,@b
		cmpeq	d0,d2,@b
		cmp.b	d3,d0
		bhi	@f
		move.b	#'_',-(a0)		;$20ȉS _ ɒu
		bra	ext_regular_fn_loop
@@:
		lsr.b	#5,d0
		btst	d0,#%10010000
		beq	ext_regular_fn_loop	;1oCg
		tst.b	(a0)+
		bne	ext_regular_fn_loop
ext_regular_fn_end:


;WJΏۂ̃t@Cׂ
		lea	(pad+pathname,a5),a1
		bsr	filename_compare
		bne	pass

;kTCYZ
		move.l	(pad+LH0_packed_size,a5),d0
		add.l	d0,(src_total_size-work,a6)

;WJTCYZ
		move.l	(pad+LH0_original_size,a5),d1
.ifdef EARLY_ATR_FIX
		beq	@f			;TCY=0oCg
		tst.b	(pad+LH0_header_level,a5)
		bne	@f			;lv0/lv1
		move.b	(pad+LH0_attribute,a5),d0
		bclr	#ATR_DIR,d0
		beq	@f			;t@C

;wb_x 0AfBNgAIWiTCY > 0
;Ȃt@CɕύXB
		bset	#ATR_ARC,d0
		move.b	d0,(pad+LH0_attribute,a5)
		EPRINT	(pad+pathname,a5)
		EPRINT	(fix_atr_message-work,a6)
@@:
.endif
		add.l	d1,(ext_total_size-work,a6)

;WJt@CZ
		addq	#1,(file_total-work,a6)


;t@C̏\
		lea	(a4),a1
		bsr	display
		PRINT	(crlf,pc)

		btst	#F_LIST,D7
		bne	list

		moveq	#0,d4			;-lh?-
		move.b	(pad+LH0_method_id+.sizeof.('-lh'),a5),d4

.ifdef __EX__
		clr.b	(division_flag,a6)

		move	d4,d0
		subi.b	#'0',d0
		cmpi.b	#7,D0
		bhi	@f
.if MPU>=68020
		move.l	(dictionary_size_table,pc,d0.w*4),(dictionary_size,a6)
.else
		lsl	#2,d0
		move.l	(dictionary_size_table,pc,d0.w),(dictionary_size,a6)
.endif
		bra	@f
dictionary_size_table:
		.dc.l	$000000,$ffffff,$ffffff,$ffffff
		.dc.l	$001000,$002000,$008000,$010000
		.even
@@:
.endif ;__EX__

extract2a:
		move.l	#margin,d0
		cmpne	#'1',d4,@f

		addi	#lh1_dic_size,d0
		add.l	(pad+LH0_packed_size,a5),d0
@@:
		add.l	(pad+LH0_original_size,a5),d0
		add.l	a4,d0
		cmp.l	(temp_bottom,a6),d0
		bcs	extract3		;kf[^{WJTCY̋󂫂

		bsr	file_write		;܂ł̓WJt@Cꊇo

		movea.l	(temp_top,a6),a0
		cmpa.l	a0,a5
.ifdef __EX__
		beq	extract2b
.else
		beq	memory_error		;obt@SgĂ܂Ȃ
.endif

;obt@̓rōƂĂꍇ
;ꊇoŃobt@擪󂢂̂ŋl߂
@@:
		move.l	(a5)+,(a0)+		;wb_Rs[
		cmpa.l	a4,a5
		bcs	@b

		suba.l	a5,a0			;AhX␳
		adda.l	a0,a4
		movea.l	(temp_top,a6),a5
		bra	extract2a		;xobt@eʃ`FbN

.ifdef __EX__
;łɃobt@擪ňꊇWJłȂȂAWJɂ
extract2b:
		move.l	(temp_bottom,a6),d0
		sub.l	a4,d0			;cobt@e
		sub.l	(dictionary_size,a6),d0
		asr.l	#1,d0
		andi	#$fc00,d0
		cmpi.l	#margin,d0
		blt	memory_error

		move.l	d0,(division_size,a6)	;WJs
		st	(division_flag,a6)
		bclr	#F_CACHE,d7		;Ȍ̈ꊇo߂
		bra	extract3
.endif

extract3:
		cmpeq	#'d',d4,make_directory	;-lhd-

		move.l	(pad+LH0_original_size,a5),d0
		bne	@f
		btst	#ATR_DIR,(pad+LH0_attribute,a5)
		bne	make_directory
@@:
		move.l	d0,(percentage_work1,a6)
		clr.l	(percentage_work2,a6)
		clr.b	(percentage_flag,a6)

		move	#1<<F_PRINT+1<<F_CACHE+1<<F_TEST,d0
		and	d7,d0
		bne	@f			;o͍sȂ(܂́A܂sȂ)

		movea.l	a5,a0
		bsr	file_create
		tst.l	d0
		bmi	pass
		move	d0,(file_handle-work,a6)
@@:

		cmpeq	#'0',d4,extract_lh0	;-lh0-
		cmpeq	#'1',d4,extract_lh1	;-lh1-

		subi.b	#'4',d4
		move.l	#14<<16+4,(dictionary_branch_level,a6)
		subq.b	#2,d4
		bcs	@f			;-lh4- -lh5-

		move.l	#17<<16+5,(dictionary_branch_level,a6)
		subq.b	#2,d4			;-lh6- -lh7-
		bcc	unknown_format_error
@@:
		bclr	#F_LH1,d7

		setquad	a4
		move.l	a4,(pad+extdata_adr,a5)	;WJf[^̃AhX

		move.l	(pad+LH0_original_size,a5),d4
		move.l	(pad+LH0_packed_size,a5),d1
.ifdef __EX__
		tst.b	(division_flag,a6)
		beq	@f
		move.l	(division_size,a6),d0
		move.l	(dictionary_size,a6),d4
		add.l	d0,d4
		cmp.l	d0,d1
		bcs	@f
		move.l	d0,d1
@@:
.endif
	add.l	A4,D4
	movea.l	A4,A3

		move.l	(temp_bottom,a6),d0
	sub.l	D1,D0
	subq.l	#8,D0
	subq.l	#8,D0
	cmp.l	D4,D0
	bcs	@f
	move.l	D4,D0
@@:
	addq.l	#3,D0
	andi.w	#$FFFC,D0
	movea.l	D0,A4
	move.l	D1,-(SP)
	move.l	A4,-(SP)
	move.w	D6,-(SP)
	DOS	_READ
	addq.w	#6,SP
	cmp.l	(SP)+,D0
	bne	file_read_error

		sub.l	d0,(pad+LH0_packed_size,a5)	;c舳kf[^

.ifdef __EX__
		move.l	a4,(src_top_address,a6)
		tst.b	(division_flag,a6)
		beq	@f
		move.l	d4,(ext_bottom_address2,a6)
		sub.l	(dictionary_size,a6),d4
@@:
.endif
		move.l	d4,(ext_bottom_address,a6)


;;;; LZ Huffman ̓WJ[`
	push	D6-D7/A5
		move	(dictionary_branch_level,a6),-(sp)
	move.w	#$0100,D4
	move.l	(A4)+,D5
	moveq	#16-1,D6
	move.w	#510,D7
	lea	table1(A6),A1
	lea	table2(A6),A2
	lea	branch_table(A6),A5
extract4:
	bsr	make_huffman_table
extract5:
	move.l	D5,D0
	clr.w	D0
	swap	D0
	ror.l	#16-el1,D0
	add.w	D0,D0
	add.w	D7,D0
	move.w	0(A1,D0.w),D0
	cmp.w	D7,D0
	bcs	extract5b
	move.l	D0,D1
	swap	D1
extract5a:
	add.w	D1,D1
	bcc	@f
	addq.w	#2,D0
@@:
	move.w	0(A5,D0.w),D0
	cmp.w	D7,D0
	bcc	extract5a
extract5b:
	move.b	0(A1,D0.w),D1
	BITPASS	D1

	sub.w	D4,D0
	bcc	extract6
	move.b	D0,(A3)+
.ifdef __EX__
		tst.b	(division_flag,a6)
		beq	@f
		cmpa.l	(ext_bottom_address,a6),a3
		bne	@f
		bsr	file_addition
@@:
.endif
	dbra	D3,extract5
	bra	extract7c

extract6:
	move.l	D5,D2
	clr.w	D2
	rol.l	#el2,D2
.if MPU>=68020
		move	(20,a2,d2.w*2),d2
.else
		add	d2,d2
		move	(20,a2,d2.w),d2
.endif
	cmp.w	(SP),D2
	bcs	extract6b
	move.l	D2,D1
	swap	D1
extract6a:
	add.w	D1,D1
	bcc	@f
	addq.w	#2,D2
@@:
	move.w	0(A5,D2.w),D2
	cmp.w	(SP),D2
	bcc	extract6a
extract6b:
	move.b	0(A2,D2.w),D1
	BITPASS	D1

	ext.l	D2
	move.w	D2,D1
	subq.w	#1,D1
	bls	@f
	BITREG	D1,D2
	ext.l	D2
	bset	D1,D2
@@:
	addq.w	#3,D0
	not.l	D2
	lea	0(A3,D2.l),A0

extract7:
.ifdef __EX__
		tst.b	(division_flag,a6)
		beq	extract7_b

	moveq	#0,D2
	move.w	D0,D2
	add.l	A3,D2
		sub.l	(ext_bottom_address,a6),d2
		bcs	extract7_b
	sub.w	D2,D0
	beq	extract7_a
	subq.w	#1,D0
@@:
	move.b	(A0)+,(A3)+
	dbra	D0,@b
extract7_a:
	bsr	file_addition
	move.w	D2,D0
extract7_b:
.endif

.ifdef __FAST__
	neg.w	D0
	addi.w	#256,D0
.if MPU>=68020
		jmp	(extract7a,pc,d0.w*2)
.else
		add	d0,d0
		jmp	(extract7a,pc,d0.w)
.endif
extract7a:
	.rept	256
	move.b	(A0)+,(A3)+
	.endm
.else
	moveq	#$0F,D1
	and.w	D0,D1
	add.w	D1,D1
	neg.w	D1
	jmp	extract7a(PC,D1.w)
	.rept	15
	move.b	(A0)+,(A3)+
	.endm
extract7a:
	lsr.w	#4,D0
	beq	extract7b
	subq.w	#1,D0
@@:
	.rept	16
	move.b	(A0)+,(A3)+
	.endm
	dbra	D0,@b
extract7b:
.endif

	dbra	D3,extract5

extract7c:
	movea.l	2+4*2(SP),A0
	bsr	percentage
		cmpa.l	(ext_bottom_address,a6),a3
		bcs	extract4
	bsr	illegal_archive_error

extract8:
	addq.w	#2,SP
	pop	D6-D7/A5
;;;;܂ LZ Huffman ̓WJ[`


extract8a:
		move.b	(crc_check_level-work,a6),d0
extract8a_:	tst.b	d0
		bne	@f		;CRCeXgsȂ

		move.l	(pad+LH0_original_size,a5),d1
		movea.l	(pad+extdata_adr,a5),a0
		bsr	crc_check
		cmp	(crc,a6),d2
		bne	crc_error
@@:
		move.l	(link-work,a6),(a5)	;wb_{WJf[^̃ubN
		move.l	a5,(link-work,a6)	;ꊇopXg̖Ɍq
		movea.l	a3,a5		;̃obt@

		btst	#F_CACHE,D7
		bne	@f
		bsr	file_write	;ꊇoȂȂ獡o
@@:
extract8b:
	move.w	status-work(A6),D0
	btst	#F_CACHE,D0
	beq	@f
	bset	#F_CACHE,D7
@@:
	subq.w	#1,request_total-work(A6)
	bne	extract1
	bra	extract9

make_directory:
		bsr	file_write

		move	#1<<F_PRINT+1<<F_NO_DIR+1<<F_TEST,d0
		and	d7,d0
		bne	make_directory1

		lea	(pad+pathname,a5),a1
		bsr	base		;-bIvV̏

		pea	(a1)
@@:
		tst.b	(A1)+
		bne	@b
		clr.b	(-2,a1)		;̃pXf~^
		DOS	_MKDIR
		movea.l	(sp)+,a1
		tst.l	d0
		bmi	make_directory1

;fBNg̃^CX^vƑς
mkdir_chg_date:
		move	#1<<ATR_ARC,-(sp)
		move.l	a1,-(sp)
		DOS	_CHMOD
		tst.l	d0
		bmi	@f

		move	#2,(4,sp)	;ǂݏ[h
		DOS	_OPEN
		move.l	d0,d1
		bmi	@f

		move.l	(pad+LH0_time,a5),-(sp)
		move	d1,-(sp)
		DOS	_FILEDATE
		DOS	_CLOSE
		addq.l	#6,sp
@@:
		moveq	#1<<ATR_DIR,D0
		or.b	(pad+LH0_attribute,a5),d0
		move	d0,(4,sp)
		DOS	_CHMOD
		addq.l	#6,SP

make_directory1:
		movea.l	(temp_top,a6),a5
		bra	extract8b

extract9:
		tst.b	d7			;F_LIST_1
		bmi	@f			;-1w莞total\Ȃ

		PRINT	(item_list2-work,a6)
		lea	(branch_table,a6),a5
		bsr	make_total_header	;[wb_
		bsr	display
		PRINT	(item_list3-work,a6)
@@:
extractE:
	bsr	file_write
	move.w	status-work(A6),D7
		movea.l	(stack2,a6),sp
		rts

list:
pass:
		move.l	(pad+LH0_packed_size,a5),d0
		beq	@f			;kf[^Ȃ

		move	#SEEK_CUR,-(sp)		;kf[^΂
		move.l	d0,-(sp)
		move	d6,-(sp)
		DOS	_SEEK
		addq.l	#8,SP
		tst.l	d0
		bmi	file_read_error
@@:
		bra	extract1


;[wb_
make_total_header:
		lea	(a5),a0
		move.l	#'t',(a0)+		;pad,header_size/sum,method_id
		move.l	#'otal',(a0)+		;method_id
		move.l	(src_total_size-work,a6),(a0)+	;packed_size
		move.l	(ext_total_size-work,a6),(a0)+	;original_size

		clr.l	-(sp)
		move	d6,-(sp)
		DOS	_FILEDATE
		addq.l	#6,sp
		move.l	d0,(a0)+		;date/time

		st	(a0)+			;attribute
		lea	(pad+pathname,a5),a1
		moveq	#0,d0
		move	(file_total-work,a6),d0
		moveq	#3,d1
		cmpi	#999,d1
		bls	@f
		cmpi	#9999,d1
		sls	d1
		addq.b	#5,d1
@@:		bsr	cnv_num

		addq.l	#1,a1			;displayŎgobt@
		rts



;-lh0-̓WJ
extract_lh0:
		movea.l	a4,a3
		move.l	a3,(pad+extdata_adr,a5)
.ifdef __EX__
		move.l	(division_size,a6),d1
		add.l	d1,d1
		move.l	d1,(division_size,a6)
extract_lh0_1:
		tst.b	(division_flag,a6)
		beq	extract_lh0_2

	move.l	D1,-(SP)
	move.l	A3,-(SP)
	move.w	D6,-(SP)
	DOS	_READ
	addq.w	#6,SP
	cmp.l	(SP)+,D0
	bne	file_read_error

	push	D6-D7/A5
	subq.w	#2,SP
	bsr	file_addition
	addq.w	#2,SP
	pop	D6-D7/A5
	movea.l	A5,A0
	bsr	percentage
	bra	extract_lh0_1
extract_lh0_2:
.endif
		move.l	(pad+LH0_original_size,a5),-(sp)
	move.l	A3,-(SP)
	move.w	D6,-(SP)
	DOS	_READ
	addq.w	#6,SP
	cmp.l	(SP)+,D0
	bne	file_read_error
	adda.l	D0,A3

		move.b	(crc_check_level-work,a6),d0
		beq	@f
		subq.b	#1,d0
@@:		bra	extract8a_



;-lh1-̓WJ
extract_lh1:
		setquad	a4
		move.l	a4,(pad+extdata_adr,a5)

make_dictionary:
	move.l	#$20202020,D0
	moveq	#60/4-1,D1
@@:
	move.l	D0,(A4)+
	dbra	D1,@b
	move.l	#$01010101,D2
	moveq	#0,D0
	moveq	#256/2-1,D1
@@:
	move.l	D0,(A4)+
	move.l	D0,(A4)+
	move.l	D0,(A4)+
	move.b	D0,(A4)+
	add.l	D2,D0
	move.b	D0,(A4)+
	move.l	D0,(A4)+
	move.l	D0,(A4)+
	move.l	D0,(A4)+
	add.l	D2,D0
	dbra	D1,@b
	lsl.l	#2,D2
	move.l	#$00010203,D0
	moveq	#256/4-1,D1
@@:
	move.l	D0,(A4)+
	add.l	D2,D0
	dbra	D1,@b
	move.l	#$FFFEFDFC,D0
	moveq	#256/4-1,D1
@@:
	move.l	D0,(A4)+
	sub.l	D2,D0
	dbra	D1,@b
	moveq	#0,D0
	moveq	#128/4-1,D1
@@:
	move.l	D0,(A4)+
	dbra	D1,@b
	move.l	#$20202020,D0
	moveq	#68/4-1,D1
@@:
	move.l	D0,(A4)+
	dbra	D1,@b
make_dictionary9:



make_dynamic_table:
	lea	lh1_length_table-2(A6),A0
	lea	lh1_branch_table(A6),A1
	lea	lh1_dis_branch_table+627*2(A6),A2
	clr.w	(A0)+
	movea.l	A0,A3
	moveq	#1,D0
	move.w	#627*2,D1
	moveq	#0,D2
	move.w	#314-1,D3
@@:
	move.w	D0,(A0)+
	move.w	D1,(A1)+
	move.w	D2,(A2)+
	addq.w	#2,D1
	addq.w	#2,D2
	dbra	D3,@b

	lea	lh1_dis_branch_table(A6),A2
	moveq	#0,D1
	move.w	#314*2,D2
	move.w	#313-1,D3
@@:
	move.w	(A3)+,D0
	add.w	(A3)+,D0
	move.w	D0,(A0)+
	move.w	D1,(A1)+
	move.w	D2,(A2)+
	move.w	D2,(A2)+
	addq.w	#4,D1
	addq.w	#2,D2
	dbra	D3,@b
	move.w	#$FFFF,(A0)+
	clr.w	(A2)+
make_dynamic_table9:


;WJɑΉĂȂ悤ȋC??
		movea.l	a4,a3
		adda.l	(pad+LH0_original_size,a5),a4
		move.l	a4,d4
		setquad	a4
		move.l	(pad+LH0_packed_size,a5),-(sp)
		pea	(a4)
		move	d6,-(sp)
		DOS	_READ
		addq.l	#6,sp
		cmp.l	(sp)+,d0
		bne	file_read_error


init_lh1_table:
	bset	#F_LH1,D7
	bne	init_lh1_table9

	lea	lh1_table_init_data-work(A6),A0
	lea	lh1_table1(A6),A1
	moveq	#0,D0
init_lh1_table1:
	moveq	#0,D2
	moveq	#0,D3
	move.b	(A0)+,D2
	move.b	(A0)+,D3
init_lh1_table2:
	move.w	D2,D1
@@:
	move.b	D0,(A1)+
	dbra	D1,@b
	addq.w	#4,D0
	dbra	D3,init_lh1_table2
	tst.b	(A0)
	bpl	init_lh1_table1

	addq.w	#1,A0
	move.l	#$01010101,D2
	move.l	D2,D0
init_lh1_table3:
	moveq	#0,D1
	move.b	(A0)+,D1
@@:
	move.l	D0,(A1)+
	dbra	D1,@b
	add.l	D2,D0
	tst.b	(A0)
	bpl	init_lh1_table3
init_lh1_table9:



extract_lh1_1:
	push	D4/D6-D7/A5
	move.w	#$0100,D4
	move.l	(A4)+,D5
	moveq	#16-1,D6
	move.w	#627*2,D7
	lea	lh1_length_table(A6),A1
	lea	lh1_branch_table(A6),A2
	lea	lh1_dis_branch_table(A6),A5
extract_lh1_2:



get_one_data:
	move.w	(627-1)*2(A2),D0
	cmp.w	D7,D0
	bcc	get_one_data9
get_one_data1:
	add.l	D5,D5
	bcc	@f
	addq.w	#2,D0
@@:
	dbra	D6,@f
	move.w	(A4)+,D5
	moveq	#16-1,D6
@@:
	move.w	0(A2,D0.w),D0
	cmp.w	D7,D0
	bcs	get_one_data1
get_one_data9:



change_dynamic_table:
	move.w	D0,-(SP)

	tst.w	-2(A1,D7.w)
	bpl	change_dynamic_table5

	push	A1-A4
	movea.l	A1,A3
	movea.l	A2,A4
	lea	0(A1,D7.w),A0
change_dynamic_table1:
	move.w	(A2)+,D0
	cmp.w	D7,D0
	bcs	@f
	move.w	D0,(A4)+
	move.w	(A1),D0
	addq.w	#1,D0
	lsr.w	#1,D0
	move.w	D0,(A3)+
@@:
	addq.w	#2,A1
	cmpa.l	A0,A1
	bcs	change_dynamic_table1

	movem.l	(SP),A1-A2
	move.w	#628,D2
	moveq	#0,D3
change_dynamic_table2:
	lea	0(A1,D2.w),A3
	lea	0(A2,D2.w),A4
	move.w	0(A1,D3.w),D0
	add.w	2(A1,D3.w),D0
	movea.l	A3,A0
@@:
	cmp.w	-(A0),D0
	bcs	@b
	addq.w	#2,A0
	move.l	A3,D1
	sub.l	A0,D1
	lsr.w	#1,D1
	bra	@f
change_dynamic_table3:
	move.w	-(A3),2(A3)
	move.w	-(A4),2(A4)
@@:
	dbra	D1,change_dynamic_table3
	move.w	D0,(A3)
	move.w	D3,(A4)
	addq.w	#4,D3
	addq.w	#2,D2
	cmp.w	D7,D2
	bcs	change_dynamic_table2

	pop	A1-A4
	movea.l	A2,A0
	moveq	#0,D3
change_dynamic_table4:
	move.w	(A0)+,D0
	cmp.w	D7,D0
	bcc	@f
	move.w	D3,2(A5,D0.w)
@@:
	move.w	D3,0(A5,D0.w)
	addq.w	#2,D3
	cmp.w	D7,D3
	bcs	change_dynamic_table4
change_dynamic_table5:

	move.w	(SP),D0
	move.w	0(A5,D0.w),D0
change_dynamic_table7:
	lea	0(A1,D0.w),A0
	addq.w	#1,(A0)
	move.w	(A0)+,D2
	cmp.w	(A0)+,D2
	bls	change_dynamic_table8
	move.w	D0,D1
@@:
	addq.w	#2,D1
	cmp.w	(A0)+,D2
	bhi	@b
	subq.w	#4,A0
	move.w	(A0),0(A1,D0.w)
	move.w	D2,(A0)
	move.w	0(A2,D0.w),D2
	move.w	0(A2,D1.w),D3
	move.w	D1,0(A5,D2.w)
	cmp.w	D7,D2
	bcc	@f
	move.w	D1,2(A5,D2.w)
@@:
	move.w	D0,0(A5,D3.w)
	cmp.w	D7,D3
	bcc	@f
	move.w	D0,2(A5,D3.w)
@@:
	move.w	D3,0(A2,D0.w)
	move.w	D2,0(A2,D1.w)
	move.w	D1,D0
change_dynamic_table8:
	move.w	0(A5,D0.w),D0
	bne	change_dynamic_table7

	move.w	(SP)+,D0
	sub.w	D7,D0
	lsr.w	#1,D0
change_dynamic_table9:



extract_lh1_3:
	sub.w	D4,D0
	bcc	extract_lh1_4
	move.b	D0,(A3)+
	cmpa.l	(SP),A3
	bcs	extract_lh1_2
	bra	extract_lh1_6

extract_lh1_4:
	lea	lh1_table2(A6),A0
	BIT	8,D1
	moveq	#0,D2
	move.b	0(A0,D1.w),D2
	move.l	D5,D3
	move.w	D1,D3
	rol.l	D2,D3
	andi.w	#$003F,D3
	BITPASS	D2
	sub.w	D4,D1
	move.b	0(A0,D1.w),D2
	lsl.w	#6-2,D2
	or.w	D2,D3
	not.w	D3
	lea	0(A3,D3.w),A0

	addq.w	#3,D0
	lsr.w	D0
	bcc	@f
	move.b	(A0)+,(A3)+
@@:
	lsr.w	D0
	bcc	@f
	move.b	(A0)+,(A3)+
	move.b	(A0)+,(A3)+
@@:
	subq.w	#1,D0
	bcs	extract_lh1_5
@@:
	move.b	(A0)+,(A3)+
	move.b	(A0)+,(A3)+
	move.b	(A0)+,(A3)+
	move.b	(A0)+,(A3)+
	dbra	D0,@b

extract_lh1_5:
	cmpa.l	(SP),A3
	bcs	extract_lh1_2
extract_lh1_6:
	bsr	illegal_archive_error

extract_lh1_8:
.if 0
	movea.l	3*4(SP),A1
	movea.l	$0014(A1),A1		; (pad+extdaaata_adr,a1) ???
	lea	lh1_dic_size(A1),A0
.endif
		movea.l	(3*4,sp),a5
		movea.l	(pad+extdata_adr,a5),a1	;WJobt@擪
		lea	(lh1_dic_size,a1),a0	;ۂɓWJf[^擪
@@:
	movem.l	(A0)+,D0-D4/D6-D7/A5
	movem.l	D0-D4/D6-D7/A5,(A1)
	lea	8*4(A1),A1
	cmpa.l	(SP),A0
	bcs	@b
	pop	D4/D6-D7/A5
	suba.l	A0,A1
	lea	0(A1,D4.l),A3
		bra	extract8a



memory_alloc_error:
	EPRINT	memory_alloc_error_message-work(A6)
	bra	done

memory_error:
	pea	memory_error_message-work(A6)
	bra	@f

unknown_format_error:
	pea	unknown_format_error_message-work(A6)
@@:
	bsr	_eprint
	addq.w	#4,SP
	bra	pass

illegal_archive_error:
	beq	@f
	move.w	status-work(A6),D7
	EPRINT	illegal_archive_error_message-work(A6)
	move.w	#1,exit_code-work(A6)
	btst	#F_FORCE,D7
	beq	extractE
@@:
	rts

file_read_error:
	pea	file_read_error_message-work(A6)
	bra	@f

branch_error:
	pea	branch_error_message-work(A6)
	bra	@f

system_error:
	pea	system_error_message-work(A6)
	bra	@f

format_error:
	pea	format_error_message-work(A6)
	bra	@f
crc_error:
	pea	crc_error_message-work(A6)
@@:
	move.w	status-work(A6),D7
	bsr	_eprint
	addq.w	#4,SP
	move.w	#1,exit_code-work(A6)
	bra	extractE


****************************************************************

* nt}؂e[uWJ
* in	A1-A2
* out	D3
* break	D0-D2/A0

make_huffman_table:
	BIT	16,D3
	subq.w	#1,D3

	push	D3-D4/D7/A5
	moveq	#16+2+1,D1
	moveq	#5,D2
	moveq	#3,D3
	bsr	make_huffman_table1

	bsr	make_huffman_tableA

		move	(dictionary_branch_level,a6),d1
		move	(dictionary_bit_length,a6),d2
		moveq	#-1,d3
		bsr	make_huffman_table1

	pop	D3-D4/D7/A5
	rts

* D1 = 
* D2 = ߃rbg
* D3 = OXy[Xp

make_huffman_table1:
	movea.l	A2,A0
	moveq	#0,D0
	move.l	D0,(A0)+
	move.l	D0,(A0)+
	move.l	D0,(A0)+
	move.l	D0,(A0)+
	move.l	D0,(A0)+

	BITREG	D2,D4
	cmp.w	D1,D4
	bhi	format_error
	subq.w	#1,D4
	bcc	make_huffman_table2

	BITREG	D2,D0
	move.w	D0,D1
	swap	D0
	move.w	D1,D0
	moveq	#(1.shl.el2)/4/2-1,D1
@@:
	move.l	D0,(A0)+
	move.l	D0,(A0)+
	move.l	D0,(A0)+
	move.l	D0,(A0)+
	dbra	D1,@b
	rts

make_huffman_table2:
	movea.l	A2,A0
make_huffman_table3:
	dbra	D3,@f
	BIT	2,D0
	add.w	D0,A0
	sub.w	D0,D4
@@:
	BIT	3,D0
	cmpi.w	#7,D0
	bne	make_huffman_table4
	move.l	D5,D2
@@:
	addq.w	#1,D0
	add.l	D2,D2
	bcs	@b
	subq.w	#7,D0
	BITPASS	D0
	addq.w	#6,D0
make_huffman_table4:
	move.b	D0,(A0)+
	dbra	D4,make_huffman_table3

	moveq	#el2,D2
	movea.l	A2,A0
	lea	20(A0),A5
	moveq	#20,D7
	bsr	make_huffman_table5
		move	D7,(branch_counter,a6)
		rts

* D1 = 
* D2 = WJrbg
* A0 = rbge[u
* A5 = WJe[u

make_huffman_table5:
	push	D5-D6/A1-A4
	lea	branch_table(A6),A1
	moveq	#16,D6
	sub.w	D2,D6

	lea	-16*2(SP),SP
	moveq	#0,D0
	.rept	16/2
	move.l	D0,-(SP)
	.endm
	move.w	D0,-(SP)

	movea.l	A0,A2
	move.w	D1,D3
	subq.w	#1,D3
@@:
	move.b	(A2)+,D0
	add.b	D0,D0
	addq.w	#1,0(SP,D0.w)
	dbra	D3,@b

	lea	2(SP),A2
	moveq	#1,D5
	moveq	#0,D4
	moveq	#16-1,D3
@@:
	ror.w	#1,D5
	move.w	D4,D0
	lsl.w	D3,D0
	add.w	(A2),D4
	add.w	D4,D4
	move.w	D5,16*2(A2)
	move.w	D0,(A2)+
	dbra	D3,@b
	tst.w	D0
	bne	system_error

	lea	2(SP),A2
	moveq	#0,D5
	bset	D2,D5
	move.w	D2,D3
	subq.w	#1,D3
@@:
	move.w	D5,16*2(A2)
	ror.w	#1,D5
	move.w	(A2),D0
	lsr.w	D6,D0
	add.w	D0,D0
	move.w	D0,(A2)+
	dbra	D3,@b

.if MPU>=68020
		move	(2,sp,d2.w*2),d0
		lsr	d6,d0
		lea	(a5,d0.w*2),a4
.else
		move	d2,d0
		add	d0,d0
		move	(2,sp,d0.w),d0
		lsr	d6,d0
		add	d0,d0
		lea	(a5,d0.w),a4
.endif
	moveq	#2,D0
	lsl.w	D2,D0
	lea	0(A5,D0.w),A2
	moveq	#0,D0
@@:
	move.w	D0,(A4)+
	cmpa.l	A2,A4
	bcs	@b


	suba.l	A2,A2
make_huffman_table6:
	moveq	#0,D5
	move.b	0(A0,A2.w),D5
	beq	make_huffman_table9

.if MPU>=68020
		move	(sp,d5.w*2),d4
		move	(16*2,sp,d5.w*2),d3
		add	d3,(sp,d5.w*2)
.else
		move	d5,d0
		add	d0,d0
		move	(sp,d0.w),d4
		move	(16*2,sp,d0.w),d3
		add	d3,(sp,d0.w)
.endif
	sub.w	D2,D5
	bls	make_huffman_table8

	move.w	D4,D0
	lsl.w	D2,D4
	lsr.w	D6,D0
.if MPU>=68020
		lea	(a5,d0.w*2),a4
.else
		add	d0,d0
		lea	(a5,d0.w),a4
.endif
	subq.w	#1,D5
make_huffman_table7:
	move.w	(A4),D0
	bne	@f
	move.w	D7,D0
	addq.w	#4,D7
	move.w	D0,(A4)
	clr.l	0(A1,D0.w)
@@:
	lea	0(A1,D0.w),A4
	add.w	D4,D4
	bcc	@f
	addq.w	#2,A4
@@:
	dbra	D5,make_huffman_table7
	move.w	A2,(A4)
	bra	make_huffman_table9

make_huffman_table8:
	move.w	A2,D0
	swap	D0
	move.w	A2,D0
	lea	0(A5,D4.w),A4

	lsr.w	#2,D3
	bcc	@f
	move.w	D0,(A4)+
@@:
	lsr.w	D3
	bcc	@f
	move.l	D0,(A4)+
@@:
	lsr.w	D3
	bcc	@f
	move.l	D0,(A4)+
	move.l	D0,(A4)+
@@:
	lsr.w	D3
	bcc	@f
	move.l	D0,(A4)+
	move.l	D0,(A4)+
	move.l	D0,(A4)+
	move.l	D0,(A4)+
@@:
	subq.w	#1,D3
	bcs	make_huffman_table9
@@:
	move.l	D0,(A4)+
	move.l	D0,(A4)+
	move.l	D0,(A4)+
	move.l	D0,(A4)+
	move.l	D0,(A4)+
	move.l	D0,(A4)+
	move.l	D0,(A4)+
	move.l	D0,(A4)+
	dbra	D3,@b

make_huffman_table9:
	addq.w	#1,A2
	cmpa.w	D1,A2
	bcs	make_huffman_table6
	cmpi.w	#branch_max*4,D7
	bcc	branch_error
	lea	2+16*2+16*2(SP),SP
	pop	D5-D6/A1-A4
	rts

* in	A1-A2
* out	
* break	D0-D4/A0/A5

make_huffman_tableA:
	lea	510(A1),A1
	moveq	#0,D0
	moveq	#(510-6)/(4*2)-1,D1
@@:
	move.l	D0,-(A1)
	move.l	D0,-(A1)
	dbra	D1,@b
	move.l	D0,-(A1)
	move.w	D0,-(A1)

	BIT	9,D0
	cmpi.w	#510,D0
	bhi	format_error
	move.w	D0,D1
	bne	make_huffman_tableB

	lea	510(A1),A0
	BIT	9,D0
	move.w	D0,D1
	swap	D0
	move.w	D1,D0
	move.w	#(1.shl.el1)/4/2-1,D1
@@:
	move.l	D0,(A0)+
	move.l	D0,(A0)+
	move.l	D0,(A0)+
	move.l	D0,(A0)+
	dbra	D1,@b
	rts

make_huffman_tableB:
	movea.l	A1,A0
	ext.l	D1
	add.l	A1,D1
	moveq	#16+2+1,D3
	moveq	#0,D4
	lea	branch_table(A6),A5

make_huffman_tableC:
	move.l	D5,D0
	clr.w	D0
	rol.l	#el2,D0
.if MPU>=68020
		move	(20,a2,d0.w*2),d0
.else
		add	d0,d0
		move	(20,a2,d0.w),d0
.endif
	cmp.w	D3,D0
	bcs	make_huffman_tableE
	move.l	D0,D4
	swap	D4
make_huffman_tableD:
	add.w	D4,D4
	bcc	@f
	addq.w	#2,D0
@@:
	move.w	0(A5,D0.w),D0
	cmp.w	D3,D0
	bcc	make_huffman_tableD
make_huffman_tableE:
	move.b	0(A2,D0.w),D4
	BITPASS	D4

	subq.b	#2,D0
	bhi	case3
	beq	case2
	addq.b	#2,D0
	bne	case1
case0:
	addq.w	#1,A0
	cmpa.l	D1,A0
	bcs	make_huffman_tableC
	bra	make_huffman_tableF
case1:
	BIT	4,D0
	addq.w	#$03,D0
	adda.w	D0,A0
	cmpa.l	D1,A0
	bcs	make_huffman_tableC
	bra	make_huffman_tableF
case2:
	BIT	9,D0
	lea	$14(A0,D0.w),A0
	cmpa.l	D1,A0
	bcs	make_huffman_tableC
	bra	make_huffman_tableF
case3:
	move.b	D0,(A0)+
	cmpa.l	D1,A0
	bcs	make_huffman_tableC

make_huffman_tableF:
	move.w	#510,D1
	moveq	#el1,D2
	movea.l	A1,A0
	lea	510(A0),A5
		move	(branch_counter,a6),d7
	cmp.w	D1,D7
	bcc	@f
	move.w	D1,D7
	addq.w	#2,D7
@@:
	bsr	make_huffman_table5
	rts


****************************************************************

* Vȃwb_
* in	
* out	
* break	D0-D2/A0-A2

file_header_error:
		bsr	file_write

		movea.l	(temp_top,a6),a5
		move.l	(temp_bottom,a6),a2
	sub.l	A5,A2
	move.l	#search_length,D0
	cmpa.l	D0,A2
	bcs	@f
	move.l	D0,A2
@@:
	adda.l	A5,A2
	movea.l	A5,A0
file_header_error1:
	move.l	A2,D0
	sub.l	A0,D0
	move.l	D0,-(SP)
	move.l	A0,-(SP)
	move.w	D6,-(SP)
	DOS	_READ
	lea	10(SP),SP
	move.l	D0,D1
	sub.l	A5,A0
	add.l	A0,D1
	movea.l	A5,A0
	lea	-18(A5,D1.l),A1
	cmpa.l	A1,A0
	bcc	file_read_error
	moveq	#'-',D0
file_header_error2:
@@:
	cmpa.l	A1,A0
	bcc	file_header_error3
	cmp.b	(A0)+,D0
	bne	@b
	cmpne	#'l',(A0),@b
	cmpne	#'h',1(A0),@b
	cmpne	3(A0),D0,@b
#	tst.b	7(A0)
#	bne	@b
#	tst.b	11(A0)
#	bne	@b
#	cmpi.b	#2,17(A0)
#	bhi	@b
	subq.w	#3,A0
	suba.l	A5,A0
	suba.l	D1,A0
		move	#SEEK_CUR,-(sp)
	move.l	A0,-(SP)
	move.w	D6,-(SP)
	DOS	_SEEK
	addq.w	#8,SP
	tst.l	D0
	bmi	system_error
	bra	extract1
file_header_error3:
	movea.l	A5,A0
	moveq	#18-1,D0
@@:
	move.b	(A1)+,(A0)+
	dbra	D0,@b
	bra	file_header_error1


****************************************************************

* bqbe[u쐬
* in	A5
* out	
* break	D0-D5

make_crc_table:
		cmpi.b	#2,(crc_check_level-work,a6)
		bcc	make_crc_table9

		move.l	a5,(crc_table,a6)
	moveq	#0,D4
	moveq	#$C0,D5
	moveq	#$C1,D6
	moveq	#0,D0
	moveq	#128-1,D1
make_crc_table1:
	move.b	D0,D2
	move.b	D0,D3
	lsr.b	#1,D3
	eor.b	D3,D2
	move.b	D2,D4
	lsr.b	#1,D3
	eor.b	D3,D2
	lsr.b	#1,D3
	eor.b	D3,D2
	lsr.b	#1,D3
	eor.b	D3,D2
	lsr.b	#1,D3
	eor.b	D3,D2
	lsr.b	#1,D3
	eor.b	D3,D2
	andi.b	#1,D2
	beq	@f
	eor.b	D5,D4
@@:
	btst	#0,D0
	beq	@f
	tas	D2
@@:
	move.w	D4,(A5)+
	move.w	D2,(A5)+
	eor.b	D5,D4
	eor.b	D6,D2
	move.w	D4,(A5)+
	move.w	D2,(A5)+
	addq.w	#1,D0
	dbra	D1,make_crc_table1
make_crc_table9:
	rts

****************************************************************

* 𓀃t@Ĉbqb`FbN
* in	A5
* out	
* break	D0-D3/A0-A1

crc_check:
		move	(crc_work1,a6),d2
		move	(crc_work2,a6),d3
		movea.l	(crc_table,a6),a1
		tst.l	d1
		beq	crc_check4

	moveq	#15,D4
	and.w	D1,D4
	subq.w	#1,D4
	bcs	crc_check2
crc_check1:
	moveq	#0,D0
	move.b	(A0)+,D0
	eor.b	D2,D0
.if MPU>=68020
		move	d3,d2
		move.l	(a1,d0.w*4),d3
.else
		add	d0,d0
		add	d0,d0
		move	d3,d2
		move.l	(a1,d0.w),d3
.endif
	eor.b	D3,D2
	swap	D3
	dbra	D4,crc_check1
crc_check2:
	lsr.l	#4,D1
	subq.l	#1,D1
	bcs	crc_check4
crc_check3:
	.rept	16/2
	move.b	(A0)+,D0
	eor.b	D0,D2
.if MPU>=68020
		move.l	(a1,d2.w*4),d2
.else
		add	d2,d2
		add	d2,d2
		move.l	(a1,d2.w),d2
.endif
	eor.b	D2,D3
	swap	D2
	move.b	(A0)+,D0
	eor.b	D0,D3
.if MPU>=68020
		move.l	(a1,d3.w*4),d3
.else
		add	d3,d3
		add	d3,d3
		move.l	(a1,d3.w),d3
.endif
	eor.b	D3,D2
	swap	D3
	.endm
	dbra	D1,crc_check3
	addq.w	#1,D1
	subq.l	#1,D1
	bcc	crc_check3
crc_check4:
		move	d2,(crc_work1,a6)
		move	d3,(crc_work2,a6)
		lsl	#8,d3
		or	d3,d2
		rts


****************************************************************

* t@C̈ꊇo
* in	
* out	
* break	D0-D2/A0-A1

file_write:
		lea	(link-work,a6),a0
		move.l	(a0),d0
		beq	file_write9		;ҋ@t@CȂ

;Xg̍Ō̃t@C=ŏɓWJt@C܂ŒH
@@:		movea.l	a0,a1
		movea.l	d0,a0
		move.l	(a0),d0
		bne	@b
		move.l	d0,(a1)			;Xg̍Ō؂藣

		btst	#F_TEST,d7
		bne	file_write

		btst	#F_PRINT,d7
		beq	@f
		moveq	#STDOUT,d1
		bra	file_write8
@@:
		move	(file_handle-work,a6),d1
		bne	file_write8

		bsr	file_create
		move.l	d0,d1
		bmi	file_write
file_write8:
		clr	(file_handle-work,a6)

		move.l	(pad+LH0_original_size,a0),-(sp)
		move.l	(pad+extdata_adr,a0),-(sp)
		move	d1,-(sp)
		DOS	_WRITE
		addq.l	#6,sp
		cmp.l	(sp)+,d0
		bne	file_write_error

		btst	#F_PRINT,d7
		bne	file_write

		move.l	(pad+LH0_time,a0),-(sp)
		move	d1,-(sp)
		DOS	_FILEDATE
		DOS	_CLOSE
		addq.l	#6,sp
		bra	file_write
file_write9:
		rts

file_write_error:
		btst	#F_PRINT,d7
		beq	file_write_error2
		EPRINT	(stdout_message-work,a6)
		bra	@f
file_write_error2:
		bsr	file_delete
		EPRINT	(filename_work,a6)
@@:
		EPRINT	(file_write_error_message-work,a6)
		bra	file_write

.ifdef __EX__
file_addition:
	push	D1-D7/A0-A2
	movem.l	4*10+4+2(SP),D6-D7/A0
		move.l	(ext_bottom_address,a6),d0
		move.l	(ext_bottom_address2,a6),d1
		move.l	(division_size,a6),d2
	cmp.l	D1,D0
	beq	file_addition1
	add.l	D2,D0
	cmp.l	D1,D0
	bcs	@f
	move.l	D1,D0
@@:
		move.l	d0,(ext_bottom_address,a6)
		bra	file_addition3
file_addition1:
	move.w	file_handle-work(A6),D1
	btst	#F_PRINT,D7
	beq	@f
	moveq	#STDOUT,D1
@@:
		movea.l	(pad+extdata_adr,a0),a3
		move.l	d2,-(sp)
		pea	(a3)
		move	d1,-(sp)
		DOS	_WRITE
		addq.l	#6,sp
		cmp.l	(sp)+,d0
		bne	file_write_error

		move.b	(crc_check_level-work,a6),d0
		subq.b	#2,d0
		beq	@f

	push	D2/A0
	move.l	D2,D1
	movea.l	A3,A0
	bsr	crc_check
	pop	D2/A0
@@:

		add.l	d2,(percentage_work2,a6)
		sub.l	d2,(pad+LH0_original_size,a0)

		move.l	(pad+LH0_original_size,a0),d0
		sub.l	(dictionary_size,a6),d0
		sub.l	d2,d0
		bhi	@f

		add.l	d0,(ext_bottom_address,a6)
		clr.b	(division_flag,a6)
@@:
		lea	(a3,d2.l),a1
		move.l	(dictionary_size,a6),d1
		beq	file_addition9

	lsr.l	#4,D1
	subq.w	#1,D1
@@:
	move.l	(A1)+,(A3)+
	move.l	(A1)+,(A3)+
	move.l	(A1)+,(A3)+
	move.l	(A1)+,(A3)+
	dbra	D1,@b

file_addition3:
		movea.l	(src_top_address,a6),a1
	movea.l	A1,A2
	move.l	A4,D0
	sub.l	A1,D0
	move.l	D2,D1
	sub.l	D0,D1
	bls	system_error
	lsr.l	#1,D1
	subq.l	#1,D1
@@:
	move.w	(A4)+,(A2)+
	dbra	D1,@b
	addq.w	#1,D1
	subq.l	#1,D1
	bcc	@b

		movea.l	a1,a4
		move.l	(pad+LH0_packed_size,a0),d1
		beq	file_addition9
	cmp.l	D1,D0
	bcs	@f
	move.l	D1,D0
@@:
	move.l	D0,-(SP)
	move.l	A2,-(SP)
	move.w	D6,-(SP)
	DOS	_READ
	lea	10(SP),SP
		sub.l	d0,(pad+LH0_packed_size,a0)

file_addition9:
	pop	D1-D7/A0-A2
	rts
.endif


****************************************************************

* t@C̐VK쐬
* in	A0
* out	
* break	D0-D2/A1

file_create:
		move.l	d3,-(sp)
		lea	(pad+pathname,a0),a1

		moveq	#1<<ATR_ARC,d2
		btst	#F_ATR,D7
		beq	@f			;t@C͕Ȃ

		move.b	(pad+LH0_attribute,a0),d2
		bclr	#ATR_DIR,d2
		beq	@f

;fBNgȂC
		bset	#ATR_ARC,d2
		EPRINT	(a1)
		EPRINT	(fix_atr_message-work,a6)
@@:
		move.l	(pad+LH0_time,a0),d3
		bsr	file_create_sub
		move.l	(sp)+,d3
		rts


****************************************************************

* t@C\
* in	a1 A5
* out	
* break	D0-D2/A0-A1

display:
		tst	(message_level-work,a6)
		beq	display9
		tst.b	d7			;F_LIST_1
		bmi	display8		;-1w莞̓t@Ĉݕ\

		move.l	d3,-(sp)
		moveq	#SPC,d3

		pea	(a1)
		move.b	d3,(a1)+
		lea	(pad+LH0_method_id,a5),a0
	.rept	.sizeof.('-lh?-')
		move.b	(a0)+,(a1)+
	.endm
		move.b	d3,(a1)+
		move.b	d3,(a1)+

		lea	(cnv_num-work,a6),a0
		move.l	(pad+LH0_packed_size,a5),d0
		moveq	#8,d1
		jsr	(a0)
		move.b	d3,(a1)+

		move.l	(pad+LH0_original_size,a5),d0
		moveq	#8,d1
		jsr	(a0)
		move.b	d3,(a1)+

		move.l	(pad+LH0_packed_size,a5),d0
		move.l	(pad+LH0_original_size,a5),d1
		beq	display1
@@:
		cmpi.l	#$00010000,d1
		bcs	@f
		lsr.l	d0
		lsr.l	d1
		bra	@b
@@:
		mulu	#1000*2,d0
		divu	d1,d0
		addq	#1,d0
		lsr	#1,d0
		ext.l	d0
display1:
		moveq	#4,d1
		jsr	(a0)
		move.b	-(a1),d0		;
		cmp.b	-(a1),d3
		bne	@f
		move.b	#'0',(a1)
@@:		addq.l	#1,a1

		move.b	#'.',(a1)+
		move.b	d0,(a1)+
		move.b	#'%',(a1)+

		move.b	d3,(a1)+
		move.b	d3,(a1)+

		move.b	(pad+LH0_attribute,a5),d2
		cmpne	#$ff,d2,display2
		moveq	#8-1,d0			;total̕\
@@:
		move.b	d3,(a1)+
		dbra	d0,@b
		bra	display3
display2:
		moveq	#'d',d0
		btst	#ATR_DIR,d2
		bne	@f
		moveq	#'l',d0
		btst	#ATR_LINK,d2
		bne	@f
		moveq	#'-',d0
@@:		move.b	d0,(a1)+

		moveq	#'-',d0
		btst	#ATR_ARC,d2
		beq	@f
		moveq	#'a',d0
@@:		move.b	d0,(a1)+

		moveq	#'-',d0
		btst	#ATR_SYS,d2
		beq	@f
		moveq	#'s',d0
@@:		move.b	d0,(a1)+

		moveq	#'-',d0
		btst	#ATR_HID,d2
		beq	@f
		moveq	#'h',d0
@@:		move.b	d0,(a1)+

		move.b	#'r',(a1)+

		moveq	#'-',d0
		btst	#ATR_READ,d2
		bne	@f
		moveq	#'w',d0
@@:		move.b	d0,(a1)+

		moveq	#'-',d0
		tst.b	d2
		bpl	@f
		moveq	#'x',d0
@@:		move.b	d0,(a1)+

		move.b	d3,(a1)+

display3:
		move	(pad+LH0_time,a5),d2	;ЂԂĂ̂date
		rol	#7,d2
		moveq	#$7f,d0
		and	d2,d0
		addi	#80,d0
		moveq	#2,d1
		jsr	(a0)
		move.b	#'-',(a1)+

		rol	#4,d2
		moveq	#$0f,d0
		and	d2,d0
		addi	#100,d0
		moveq	#2,d1
		jsr	(a0)
		move.b	#'-',(a1)+

		rol	#5,d2
		moveq	#$1f,d0
		and	d2,d0
		addi	#100,d0
		moveq	#2,d1
		jsr	(a0)
		move.b	d3,(a1)+

		move	(pad+LH0_date,a5),d2	;ЂԂĂ̂time
		swap	d2
		rol	#5,d2
		moveq	#$1f,d0
		and	d2,d0
		addi	#100,d0
		moveq	#2,d1
		jsr	(a0)
		move.b	#':',(a1)+

		rol	#6,d2
		moveq	#$3f,d0
		and	d2,d0
		addi	#100,d0
		moveq	#2,d1
		jsr	(a0)
		move.b	#':',(a1)+

		rol	#5,d2
		moveq	#$1f,d0
		and	d2,d0
		add	d0,d0
		addi	#100,d0
		moveq	#2,d1
		jsr	(a0)
		move.b	d3,(a1)+

		clr.b	(a1)
		DOS	_PRINT
		addq.l	#4,sp

		move.l	(sp)+,d3
display8:
		pea	(pad+pathname,a5)
		DOS	_PRINT
		addq.l	#4,sp
display9:
		rts


****************************************************************

* Ɛis󋵕\
* in	A0/A3
* out	
* break	D0-D2/A1

percentage:
		tst	(message_level-work,a6)
		beq	percentage9
		move.l	(percentage_work1,a6),d1
		beq	percentage9		;Length=0 ΍

		move.l	a3,d0
		sub.l	(pad+extdata_adr,a0),d0
		add.l	(percentage_work2,a6),d0

		tst.b	(percentage_flag,a6)
		bne	@f
		cmp.l	d1,d0
		beq	percentage9
@@:
	moveq	#1,D2
	swap	D2
@@:
	cmp.l	D2,D1
	bcs	@f
	lsr.l	#2,D0
	lsr.l	#2,D1
	bra	@b
@@:
	mulu	#100,D0
	divu	D1,D0
	ext.l	D0
	moveq	#3,D1
	move.l	A1,D2
	lea	-10(SP),SP
	movea.l	SP,A1
	move.l	A1,-(SP)
	bsr	cnv_num
	move.b	#'%',(A1)+
	move.l	#BS<<24+BS<<16+BS<<8+BS,(A1)+
	clr.b	(A1)+
	bsr	_eprint
	lea	4+10(SP),SP
	movea.l	D2,A1
		st	(percentage_flag,a6)
percentage9:
		rts


****************************************************************

* R}hC
* in	A2/A5
* out	D7
* break	D0/A0

get_command:

hupair:
	lea	1024(A5),A0
	st	(A0)+
	move.l	A0,-(SP)
hupair1:
	move.b	(A2)+,D0
	beq	hupair5
	cmpeq	#SPC,D0,hupair1
	subq.w	#1,A2
hupair2:
	move.b	(A2)+,D0
	cmpeq	#"'",D0,hupair4
	cmpeq	#'"',D0,hupair4
	cmpeq	#SPC,D0,hupair3
	cmpne	#'\',D0,@f
	moveq	#'/',D0
@@:
	move.b	D0,(A0)+
	beq	hupair5
		lsr.b	#5,d0
		btst	d0,#%10010000
		beq	hupair2
	move.b	(A2)+,(A0)+
	bra	hupair2
hupair3:
	tst.b	-1(A0)
	beq	hupair1
	clr.b	(A0)+
	bra	hupair1
hupair4:
	move.b	(A2)+,D1
	cmpeq	D0,D1,hupair2
	cmpne	#'\',D1,@f
	moveq	#'/',D1
@@:
	move.b	D1,(A0)+
	beq	hupair5
		lsr.b	#5,d0
		btst	d0,#%10010000
		beq	hupair4
	move.b	(A2)+,(A0)+
	bra	hupair4
hupair5:
	clr.b	(A0)
	move.l	(SP)+,A2
hupair9:

get_command1:
	move.b	(A2)+,D0
	beq	get_command8
	cmpeq	#'-',D0,switch
	subq.w	#1,A2
	bset	#F_ARC,D7
	bne	get_command2
		move.l	a5,(lzh_file,a6)
@@:
	move.b	(A2)+,(A5)+
	bne	@b
	addq.w	#4,A5
	bra	get_command1

get_command2:
	bset	#F_EXT,D7
	bne	@f
		move.l	a5,(ext_file,a6)
@@:
	move.b	(A2)+,(A5)+
	bne	@b
	lea	-4(A5),A0
	moveq	#'*',D0
	cmpne	(A0)+,D0,get_command1
	cmpne	#'.',(A0)+,get_command1
	cmpne	(A0)+,D0,get_command1
	subq.w	#3,A5
	clr.b	(A5)+
	bra	get_command1

switch0:
	bset	D0,D7
switch:
	move.b	(A2)+,D0
	beq	get_command1
	cmpeq	#'?',D0,help
	cmpeq	#'1',D0,s_list
	ori.b	#$20,D0
	cmpeq	#'h',D0,help
	cmpeq	#'l',D0,s_list1
	cmpeq	#'v',D0,s_list1
	cmpeq	#'e',D0,s_extract
	cmpeq	#'x',D0,s_extract1
	cmpeq	#'a',D0,s_attribute
	cmpeq	#'b',D0,s_base
	cmpeq	#'c',D0,s_not_compare_time
	cmpeq	#'m',D0,s_not_inquire
	cmpeq	#'n',D0,s_no_message
	cmpeq	#'i',D0,s_byte_code_check
	cmpeq	#'t',D0,s_archive_test
	cmpeq	#'w',D0,s_write_cache
	cmpeq	#'p',D0,s_output_console
	cmpeq	#'s',D0,s_disk_free_check
	cmpeq	#'f',D0,s_force_extract

switch_error:
	pea	switch_error_message-work(A6)
	bra	@f

command_error:
	pea	command_error_message-work(A6)
	bra	@f

help:
	pea	help_message-work(A6)
@@:
	bsr	_eprint
	addq.w	#4,SP
	bra	done

s_list:
	bset	#F_LIST_1,D7
s_list1:
	moveq	#F_LIST,D0
	bra	switch0

s_extract:
	bset	#F_NO_DIR,D7
s_extract1:
		bsr	get_num
		move.b	d0,(crc_check_level-work,a6)
		subq	#2,d0
		bhi	command_error
		bra	switch

s_attribute:
	moveq	#F_ATR,D0
	bra	switch0

s_base:
	tst.b	(A2)
	bne	@f
	addq.w	#1,A2
@@:
	tst.b	(A2)
	beq	command_error

		bset	#F_BASE,d7
		move.l	a2,(base_directory,a6)
@@:
	tst.b	(A2)+
	bne	@b
	bra	get_command1

s_output_console:
	bset	#F_PRINT,D7

s_no_message:
		bsr	get_num
		cmpi	#2,d0
		bhi	command_error
		move	d0,(message_level-work,a6)
		bne	switch			;-n0̂Ƃ-mɎw

s_not_inquire:
	moveq	#F_NO_INQ,D0
	bra	switch0

s_byte_code_check:
	moveq	#F_CASE,D0
	bra	switch0

s_not_compare_time:
		bsr	get_num
		move.b	d0,(compare_level-work,a6)
		subq	#2,d0
		bhi	command_error
		bra	switch

s_archive_test:
	bset	#F_TEST,D7
	bra	s_extract1

s_disk_free_check:
		clr.b	(disk_free_check_flag-work,a6)
		bclr	#F_CACHE,d7
		bra	switch

s_write_cache:
		st	(disk_free_check_flag-work,a6)
		moveq	#F_CACHE,d0
		bra	switch0

s_force_extract:
	moveq	#F_FORCE,D0
	bra	switch0

get_command8:
	rts

get_command9:
	tst.w	D7
	bpl	help

	clr.b	(A5)+
	btst	#F_BASE,D7
	beq	get_command9a

		movea.l	(base_directory,a6),a2
		move.l	a5,(base_directory,a6)
@@:
	move.b	(A2)+,(A5)+
	bne	@b
	subq.w	#2,A5
	cmpeq	#':',(A5)+,@f
	moveq	#'/',D0
	cmpeq	-1(A5),D0,@f
	move.b	D0,(A5)+
@@:
	clr.b	(A5)+

get_command9a:
	btst	#F_EXT,D7
	beq	get_command9e
		movea.l	(ext_file,a6),a2
		moveq	#0,d1
get_command9b:
	tst.b	(A2)
	beq	get_command9d
@@:
	move.b	(A2)+,D0
	beq	@f
	cmpeq	#'?',D0,get_command9c
	cmpeq	#'*',D0,get_command9c
	bra	@b
@@:
	addq.w	#1,D1
	bne	get_command9b
get_command9c:
	moveq	#-1,D1
get_command9d:
	move.w	D1,request_total-work(A6)
get_command9e:
	rts


* ^CX^vϊ -------------------------- *

unix2dostime:
		PUSH	d1-d3/a0
		addi.l	#9*60*60-(10*365+2)*24*60*60,D0

		moveq	#0,d2
		swap	d0
		move	d0,d2
		divu	#60*60,d2
		move	d2,d0
		swap	d0
		move	d0,d2
		divu	#60*60,d2
		move	d2,d0
		clr	d2
		swap	d2

		divu	#60,d2
		swap	d2
		ror	#6,d2
		ror.l	#6,d2
		divu	#24,d0
		move.l	d0,d1
		move	d2,d1
		ror.l	#5,d1
		move	d1,-(sp)

		moveq	#0,d1
year:
		move	#365,d3
		moveq	#3,d2
		and	d1,d2
		bne	@f
		cmpi	#200-80,d1
		beq	@f
		addq	#1,d3
@@:
		cmp	d3,d0
		bcs	@f
		sub	d3,d0
		addq	#1,d1
		bra	year
@@:
		move	d1,-(sp)

		moveq	#1,d1
		move	d3,d2
		lea	(month_table-work,a6),a0
		btst	#0,d2
		bne	@f
		lea	(month_table2-work,a6),a0
@@:
		moveq	#0,d2
@@:
		move.b	(a0)+,d2
		cmp	d2,d0
		bcs	@f
		sub	d2,d0
		addq	#1,d1
		bra	@b
@@:
		addq	#1,d0
		swap	d1
		move	d0,d1
		ror	#5,d1
		ror.l	#4,d1
		swap	d1
		move	(sp)+,d1
		ror.l	#7,d1
		move	(sp)+,d1

		move.l	d1,d0
		POP	d1-d3/a0
		rts


* Data Section -------------------------------- *

		.data
		.even

file_handle:	.ds	1

lh1_table_init_data:
		.dc.b	32-1,1-1		;0
		.dc.b	16-1,3-1		;1-3
		.dc.b	8-1,8-1			;4-11
		.dc.b	4-1,12-1		;12-23
		.dc.b	2-1,24-1		;24-47
		.dc.b	1-1,16-1		;48-63
		.dc.b	$ff
		.dc.b	32/4-1			;1
		.dc.b	48/4-1			;2
		.dc.b	64/4-1			;3
		.dc.b	48/4-1			;4
		.dc.b	48/4-1			;5
		.dc.b	16/4-1			;6
		.dc.b	$ff

lx_opt:		.dc.b	'lx_opt',0
lzh_ext:	.dc.b	'.lzh',0

unknown_format_error_message:
		.dc.b	'̃tH[}bgɂ͑ΉĂ܂',CRLF,0

fix_atr_message:
		.dc.b	' t@CɎw肳ꂽsȃfBNg𖳎܂',CRLF,0

illegal_archive_error_message:
		.dc.b	'ɍ\ُł',CRLF,0

item_list:	.dc.b	CRLF
		.dc.b	'Method    Size    Length   Ratio    Atr     Date     Time      Name',CRLF
item_list2:	.dc.b	'======= ======== ======== ======= ======= ======== ======== ==========',CRLF,0
item_list3:	.dc.b	' files',CRLF
crlf:		.dc.b	CRLF,0

help_message:
		.dc.b  'X68k LZH archive extractor version 1.20 patchlevel ',LX_PATCHLEVEL,CRLF
		.dc.b  ' Copyright 1994,95 M.Harashino, ',LX_PATCHDATE,' ',LX_PATCHAUTHOR,'.',CRLF
		.dc.b  'gFlx [<switch>] <lzh-file> [<ext-file> cc ]',CRLF
		.dc.b  '	-x[n]		ɂWJ(default)',CRLF
		.dc.b  '	-e[n]		ɂpX𖳎ēWJ',CRLF
		.dc.b  '	-t[n]		ɂCRCeXgs',CRLF
		.dc.b  '	-l -v -1	ɂ̈ꗗ\',CRLF
		.dc.b  '	-a		t@C',CRLF
		.dc.b  '	-b <path>	WJfBNgw肷',CRLF
		.dc.b  '	-c[n]		ƍsȂ',CRLF
		.dc.b  '	-i		啶^ʂ',CRLF
		.dc.b  '	-m		₢킹sȂ',CRLF
		.dc.b  '	-n[n]		ʕ\sȂ',CRLF
		.dc.b  '	-p[n]		Wo͂֏o͂',CRLF
		.dc.b  '	-s		󂫗eʂmF',CRLF
		.dc.b  '	-w		oꊇčs',CRLF
**		.dc.b  '	-f		sȏɂWJ',CRLF
**		.dc.b  '	-h		wvbZ[W\',CRLF
		.dc.b	0


* Offset Table -------------------------------- *


;
;lh5p       lh1p     lh1WJ
;  obt@    obt@lh5pobt@̈ꕔ𗬗p
;            
;
;ʃobt@
;            
;            
;

		.offset	0
		.ds	1
lh1_length_table:
		.ds	627+1
lh1_branch_table:
		.ds	627
lh1_dis_branch_table:
		.ds	627+314
lh1_table1:
		.ds.b	256
lh1_table2:
		.ds.b	256
lh1_bss_bottom:


		.offset	0
branch_table::
		.ds.l	branch_max
table1:
		.ds.b	510+(1<<el1)*2
		.ds	1
table2:
		.ds.b	20+(1<<el2)*2
		.ds	1
lh5_bss_bottom:

.fail lh5_bss_bottom<lh1_bss_bottom


;ȉlh1/lh5ʂ̃obt@
		.even
lzh_file:	.ds.l	1
ext_file::	.ds.l	1
base_directory::.ds.l	1

stack2:		.ds.l	1
temp_top:	.ds.l	1
temp_bottom:	.ds.l	1

dir_len:	.ds	1
dirname:	.ds.l	1
file_len:	.ds	1
filename:	.ds.l	1

		.even
crc_table:	.ds.l	1
crc:		.ds	1		;wb_ɋLqꂽCRC
crc_work1:	.ds	1		;vZr̒l
crc_work2:	.ds	1		;V

branch_counter:	.ds	1

ext_bottom_address:
		.ds.l	1

dictionary_branch_level:
		.ds	1
dictionary_bit_length:
		.ds	1

percentage_work1::
		.ds.l	1
percentage_work2:
		.ds.l	1

.ifdef __EX__
division_size:	.ds.l	1
src_top_address:.ds.l	1
dictionary_size:.ds.l	1
ext_bottom_address2:
		.ds.l	1

division_flag:	.ds.b	1
.endif

percentage_flag:
		.ds.b	1

filename_work::
		.ds.b	64+1+22+1

bss_bottom:

		.end

* End of File --------------------------------- *
