/***************************************************************
 *
 *	file: human_io.c
 *
 *	ioctl() G~[g
 *
 *	author: chapuni (GBA02750@niftyserve.or.jp)
 *	last upd. Mon Apr 11 1994
 *	this module is in public domain.
 *
 */

#include <sys/mtio.h>
#include <sys/ioctl.h>
#include <sys/dos.h>
#include <assert.h>
#include <stdarg.h>
#include <stdio.h>
#include <string.h>
#include "thread.h"

/***************************************************************
 *
 *	ioctl. Ƃ肠Ae[vɑ΂ēv
 *
 */

int ioctl(int fd, unsigned long ctl, ...)
{
  va_list ioctl_arg;
  struct mtop *op;
  char buf[32];

  if (_isthread(fd)) {
    fprintf(stderr, "FATAL: thread fd\n");
    exit(-1);
  }

  /* Ԃˁ[ */
  assert(ctl == MTIOCTOP);

  /* raw char,  ioctrl ɂȂĂ邩
     ǂ`FbN */
#if 0
  eprintf("IOCTRL = 0x%04X\n", _dos_ioctrlgt(fd));
#endif
  if ((_dos_ioctrlgt(fd) & 0x40A0) != 0x40A0)
    return -1;

  va_start(ioctl_arg, ctl);
  op = va_arg(ioctl_arg, struct mtop *);
  va_end(ioctl_arg);

  switch (op->mt_op)
    {
    case MTWEOF:
      sprintf(buf, "eof%hd", op->mt_count);
      break;
    case MTFSF:
      sprintf(buf, "fsf%hd", op->mt_count);
      break;
    case MTBSF:
      sprintf(buf, "bsf%hd", op->mt_count);
      break;
    case MTFSR:
      sprintf(buf, "fsr%hd", op->mt_count);
      break;
    case MTBSR:
      sprintf(buf, "bsr%hd", op->mt_count);
      break;
    case MTREW:
      sprintf(buf, "rewind%hd", op->mt_count);
      break;
    case MTOFFL:
      sprintf(buf, "offline%hd", op->mt_count);
      break;
    default:
#if 0
      eprintf("Ⴄ\n");
#endif
      return -1;
    }

  _dos_ioctrlwh(fd, buf, strlen(buf));

  return 0;
}

/* eof */
